
static char rcsid[] =  "$Id: makemail.c,v 1.30 1992/07/05 15:36:19 root Exp $";

/* Change Log:
$Log: makemail.c,v $
 * Revision 1.30  1992/07/05  15:36:19  root
 * first release of ATP
 *
 * Revision 1.2  1992/04/19  12:47:39  root
 * 1st semifunctional UNIX version
 *
 */


/*
+--------------------------------------------------------------------------+
|                                                                          |
|  ATP QWK Mail Reader for LINUX Copyleft and Copyright (c) 1992 KI4N TGM  |
|                                                                          |
|       Routines d'essai de reader au format Qmail - R.Cougnenc 90 -       |
|                                                                          |
|                      Small Reader for Qmail format.                      |
|                                                                          |
|        Using only tty mode and printf, this program should be compiled   |
|        on many systems with minor modifications.                         :
|                                                                          |
|                          Ren Cougnenc  1990                             |
|                                                                          |
+--------------------------------------------------------------------------+
*/


#include <time.h>
#include <stdio.h>
#ifdef __unix__
#include <fcntl.h>
#include "system.h"
#else
#include <io.h>
#endif
#include <ctype.h>
#include <stdlib.h>
#include "reader.h"
#include "qmail.h"
#include "ansi.h"
#include "makemail.h"
#include "system.h"

FILE *MsgFile,*TmpFile;
char MessageFile[MAXPATHS];

struct QmailRepType Header;

/*----------------------------------------------------------------------*/


/* Creation du bloc d'entete  du fichier message correspondant au serveur */
/*------------------------------------------------------------------------*/
/* Creation of message file header block corresponding to the server BBS  */


void FirstHeader()
{
   char Block[128], tbuf[25] ;

#ifdef _unix_
   strncpy(tbuf, CurBoard, 25);   /* Preserve lowercase name for   */
   strupr(tbuf);                  /* later use ....                */
   memset (Block,0x20,128);       /* Fill with spaces              */ 
   str2mem(Block,tbuf);           /* Insert BBS name for header    */     
#else
   strupr(CurBoard) ;             /* sait on jamais...             */
   memset (Block,0x20,128);       /* Remplissage d'espaces         */
   str2mem(Block,CurBoard);       /* Place le nom du serveur       */
#endif
  
   fwrite(Block,128,1,MsgFile);  
   fflush(MsgFile);               /* Write this block to the file  */
}
/*----------------------------------------------------------------------*/

/*  Remise du Header aux paramtres par dfaut                        */
/*----------------------------------------------------------------------*/
/*  Put the default parameters in the reply header                      */


void ResetHeader(Qmail)
struct QmailRepType *Qmail ;
{
 byte  word16[2] ; 	/* space for 16 bit unsigned word */
 int RealConfN = ConfNumbers[CurConf] ; /* given index, find real conf. num.*/ 
 char qbuf[30] ; 	/* temporary buffer */   

/* fill struct with spaces / struct remplie d'espaces    */

 memset(&Qmail->Status,0x20,sizeof(struct QmailRepType) );

 Qmail->Status   = 0x20;                        /* Public Message Unread */
 sprintf(qbuf,"%-7d",ConfNumbers[CurConf]);
 str2mem(Qmail->ConfNum, qbuf );                /* Conference Number     */
 str2mem(Qmail->MsgDate, tetedate() ) ;  /*     /* Current Date Time     */

word16[0] = (byte) ( RealConfN & 0x00ff ) ;
word16[1] = (byte) ( ( RealConfN & 0xff00 ) >> 8  )  ;
memcpy(&(Qmail->BinConfN), word16, 2 ) ; /* 16bit unsigned conference number */ 

 Qmail->MsgActive= 0xE1      ;     /* 0xE1 = active  0xE2 = non active  */
 Qmail->Unused1  = 0x20      ;     /* space                             */
 Qmail->Unused2  = 0x20      ;     /* space                             */
 Qmail->NetTag   = 0x20      ;     /* space                             */
}

/*----------------------------------------------------------------------*/
/*
           Ecriture du message proprement dit, cod selon le format
           PcBoard, c.a.d les cr/lf remplacs par  '\343'

		   Write the message encoded according to the format of PcBoard.
		   CR/LF are replaced with '\343'.
*/

int CodeMessage(fname,Qmail)
char *fname;
struct QmailRepType *Qmail ;
{
 byte ch;
 byte *ptr,*tamp;
 byte tmp[20];
 byte *tampon;          /* Pour simplifier les essais, un gros tampon...  */
 int  CountSize   = 0,  /* Sera la taille totale du texte cod sans Header */
      CountChar   = 0,
      CountBlocks = 2;  /* Le premier bloc de 128 chars est tjrs le Header */

                    /* Ouvre le fichier cr par l'diteur    */
                    /*-------------------------------------------*/
                    /* Open the reply file created by the editor */
					
   if( (tampon = (char *) malloc(MAXSIZE) ) == NULL )
   {
     printf("%s\n",txt[1] );
     fclose(MsgFile);
     return( ERROR );
   }

#ifdef __unix__
   if(( TmpFile = fopen(fname,"r")) == NULL )
#else
   if(( TmpFile = fopen(fname,"rb")) == NULL )
#endif
   {
     printf("%s %s\n",txt[ 51 ],fname);  /* "unable to open file" */
     free(tampon);
     return ERROR ;
   }
   if( setvbuf(TmpFile,NULL,_IOFBF,VBUF) )
       printf("%sCodeMsg()\n",txt[ 94 ]);  /* "Setvbuf failed..." */


/*   fread(tampon,1,sizeof(struct MyMessage),TmpFile );*/ /* skip my header */


                   /* Codage du message dans le tampon              */
                   /*-----------------------------------------------*/
                   /* Encode the reply with QWK standard characters */
				   
   tamp = tampon;
   while(fread(&ch,1,1,TmpFile))
        {
          if(ch > 0x7f ) ch = codepc[ch] ; /* translate back to DOS set */ 
          if(ch == 0x0A) ch = 227;
          if(ch == 0x0D) continue ;
          *tamp = ch;     tamp ++;
          CountChar++; CountSize ++;
          if(CountChar > 127)
            {
              CountBlocks++;
              CountChar = 0;
            }
        }

                   /* Rajout de la signature du programme */
                   /*-------------------------------------*/
                   /* Add the the tagline                 */
   ptr = CurTag;
   while(*ptr)
        {
          *tamp  =  codepc[ *ptr ] ;    /* translate Linux to Dos chars */
          if(*ptr == '\n') *tamp = 227;
          tamp++ ;  ptr++;
          CountChar++; CountSize++;
          if(CountChar > 127)
            {
              CountBlocks++;
              CountChar = 0;
            }
        }
   
    
                  /* Ajuste la taille du dernier bloc  128 octets      */
                  /*-----------------------------------------------------*/
                  /* Adjust the size of the last block to 128 bytes      */
 
  	while(CountChar < 128)
        {
          *tamp = 0x20;     tamp ++;
          CountChar++; CountSize++;
        }

                 /* Inscrit dans le Header le nombre blocs de 128 octets */
                 /*------------------------------------------------------*/
                 /* Inscribe in the header the number of 128 byte blocks */
				 
   sprintf(tmp,"%d",CountBlocks);
   str2mem(Qmail->SizeMsg,tmp);

                 /* Ecrit l'entete du message, suivi du message          */
                 /*------------------------------------------------------*/
                 /* Write the reply header followed by the reply itself  */
				 
   printf("%s...\n",txt[ 75 ]);  /* "sauvegarde du message" */
   fwrite((byte *) Qmail,1,sizeof(struct QmailRepType),MsgFile);
   fwrite(tampon,1,CountSize,MsgFile);

                /*  Ferme et efface le fichier de travail               */
                /*------------------------------------------------------*/
                /*  Close and erase the work file                       */
   fclose(TmpFile);
   unlink(fname);
   fclose(MsgFile);
   free( tampon );
   return (OK );
}
/*----------------------------------------------------------------------*/



/* Ouverture ou creation du fichier messages.                           */
/*----------------------------------------------------------------------*/
/* Open or create the message file                                      */


void OpenRepFile()
{
int FileExist;


    sprintf(MessageFile,"%s/%s%s",WorkPath,CurBoard,MSG_EXT);
    if(access(MessageFile,0) == 0) FileExist = 1;
    else FileExist = 0;



    if(FileExist)
      {
        printf("%s %s \n",txt[ 76 ],MessageFile);
        /* "Adding message to file" */
      }
    else
      {
        printf("%s %s \n",txt[77],MessageFile);
        /* "creating file" */
      }

#ifdef __unix__
    if( ( MsgFile = fopen(MessageFile,"a+")) == NULL)
#else
    if( ( MsgFile = fopen(MessageFile,"a+b")) == NULL)
#endif
    {
      printf("%s %s\n",txt[51],MessageFile); /* "unable to open file" */
      perror("System");
      return ;
    }

    if(!FileExist) FirstHeader();

}
/* le date et l'heure d'entete du message.                              */
/*----------------------------------------------------------------------*/
/* returns a pointer to the reply date/time string                      */

char * tetedate(void){

char *months[] = { "none", "JAN", "FEB", "MAR", "APR", "MAY", "JUN",
                           "JUL", "AUG", "SEP", "OCT", "NOV", "DEC" };
char *monums[] = { "00-", "01-", "02-", "03-", "04-", "05-", "06-",
                   "07-", "08-", "09-", "10-", "11-", "12-" };
int i,j;
time_t t ;
char tbuf[30] ;
static char tbuf2[30] ;

t = time(NULL);
sprintf(tbuf,"%s", ctime(&t));

tbuf[7] = '\0';
tbuf[10] = '\0';
tbuf[16] = '\0';
tbuf[21] = '-' ;
tbuf[24] = '\0'; 

for(i=1;i<13;i++) {
    j = stricmp(&tbuf[4], months[i] ) ;
    if( j == 0 ) {
        sprintf(tbuf2,"%s%s%s%s",monums[i],&tbuf[8], &tbuf[21], &tbuf[11]) ;
        i = 13 ;
    }
    if(i==12 && j!=0 )                  /* default case */         
        sprintf(tbuf2,"01-01-8001:00");
    if(tbuf2[3] == '\040')
	    tbuf2[3] = '0' ;
}

/* printf("%s\n", tbuf2 ); debug */

return(tbuf2);
} 
