
static char     rcsid[] = "$Id: qlib.c,v 1.30 1992/07/05 15:36:19 root Exp $";

/*
 * Change Log: $Log: qlib.c,v $
 * Revision 1.30   1992/07/05  15:36:19  root
 * first release of ATP
 *
 * Revision 1.2  1992/04/19  13:21:44  root 1st semifunctional UNIX version. 
 *
 */

/*
+--------------------------------------------------------------------------+
|                                                                          |
|  ATP QWK Mail Reader for LINUX Copyleft and Copyright (c) 1992 KI4N TGM  |
|                                                                          |
|       Routines d'essai de reader au format Qmail - R.Cougnenc 90 -       |
|                                                                          |
|                      Small Reader for Qmail format.                      |
|                                                                          |
|        Using only tty mode and printf, this program should be compiled   |
|        on many systems with minor modifications.                         :
|                                                                          |
|                          Ren Cougnenc  1990                             |
|                                                                          |
+--------------------------------------------------------------------------+
*/


#include <stdio.h>
#include <time.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifdef __unix__
#include <stdlib.h>
#include <unistd.h>
#else
#ifdef __TURBOC__
#include <alloc.h>
#else
#include <malloc.h>
#endif
#endif
#include "system.h"
#include "reader.h"
#include "qmail.h"
#include "readlib.h"
#include "ansi.h"

struct MsgHeaderType Qmail;

#define  call   goto


/* Variables used to read Control.dat         */

int             LastConf = 0;		/* read from control.dat number of
					 * conf. field */
int             Security = 0;
char            BoardName[50], UserName[50], First[50], City[50], HomePhone[50],
                DataPhone[50], UserName2[50];


char            ConfName[MAXCONF][NAMCONF];	/* #tgm */
int             ConfNumbers[MAXCONF];
int             ConfActive[MAXCONF];

int             dd, mm, year, hh, mn, sec;
int             exp_dd, exp_mm, exp_yy;

long            PrevOffset;
int             conf;
int             count;

/* 
 * Reads the file CONTROL.DAT pointed by Pathname. This function is not finished
 * but works well enough. 
 *
 */

int 
ReadControl(Path)
	char           *Path;
{
	FILE           *fp, *fp2;
	int             i, c, numconf;
	char            tmp[MAXPATHS], tmp2[MAXPATHS];

	sprintf(tmp, "%s/%s", Path, CNTRL_FILE);

	if ((fp = fopen(tmp, "r")) == NULL)
		call            bad_end;
	
	/*--- Get Board Name -----*/
	if (fget(BoardName, 50, fp) == NULL)
		call            bad_end;
	

	for (i = 0; i < 5; i++)
		if (fget(tmp, 126, fp) == NULL)
			call            bad_end;

	/* Get time & date        */
	sscanf(tmp, "%d-%d-%d,%d:%d:%d", &mm, &dd, &year, &hh, &mn, &sec);

	/*--- Get User Name  -----*/
	if (fget(UserName2, 50, fp) == NULL)
		call            bad_end;

	/*--- Skip 3 lines...-----*/
	for (i = 0; i < 3; i++)
		if (fget(tmp, 126, fp) == NULL)
			call            bad_end;

	/*--- Get Last conf #-----*/
	if ((fget(tmp, 126, fp) == NULL))
		call            bad_end;

	LastConf = atoi(tmp);

	 if (!LastConf || LastConf > MAXCONF)
		call            bad_end;

	/*--- Get Conf Names -----*/
	for (i = 0; i <= LastConf; i++) {
		if (fget(tmp, 126, fp) == NULL)
			call            bad_end;
		numconf = atoi(tmp);
		if (numconf < 0)
			call            bad_end;
		if (fget(ConfName[i], 15, fp) == NULL)
			call            bad_end;
		StripSpaceL(ConfName[i]);	
	    ConfNumbers[i] = numconf;
	}

	LastConf++;		/* add entry for personal mail */
	ConfNumbers[LastConf] = PERS_CONF;
	strcpy(ConfName[LastConf], txt[103]);	/* "personal" */

	fclose(fp);
	return (OK);
bad_end:
	fclose(fp);
	return (ERROR);
}

/* find actual index into array so as to locate conference name */

int 
findCindex(n)
	int             n;
{
	int             i;
	for (i = 0; i <= LastConf; i++) {
		if (ConfNumbers[i] == n)
			return (i);
	}
	return (-1);		/* return -1 if conference doesn't exist */
}


/*
 * Scans the file MESSAGE.DAT, and calls WriteIndex for writing index files. 
 */
int 
MkIndex(char *SrcDir, char *DestDir)
{
	FILE           *fs = NULL,
	               *fd = NULL,
				   *fx = NULL,
				   *pfd = NULL,
				   *pfx = NULL ;
	unsigned char  *ptr;
	int             conf = -1;
	int             iconf, persmail = FALSE ;
	int             count = 0, pcount = 0  ;
	int             oldcount = 0 ;
	register int    i;
	int             Head = sizeof(struct MsgHeaderType);
	unsigned        MaxChars, NbBlocs;
	char            Src[MAXPATHS];	/* Source file Message.DAT */
	char            Dst[MAXPATHS];	/* Conference data  file   */
	char            Idx[MAXPATHS];	/* Conference index file   */
	char            Pdst[MAXPATHS]; /* Personal conference file*/
    char            Pidx[MAXPATHS]; /* Personal index file     */
	long            last, plast , plastold ;
    int             NamLen, ffllgg = FALSE;

	NamLen = strlen(UserName);
	if (ReadControl(SrcDir)) {		/* Load new CONTROL.DAT file. */
		printf("%s !\n", txt[14]);	/* "error in control.dat" */
		return (ERROR);
 	}
  	/* Update Control.dat in bbs dir */

	sprintf(Src, "%s/%s", SrcDir, CNTRL_FILE);
	sprintf(Dst, "%s/%s", DestDir, CNTRL_FILE);
    unlink(Dst); 
	if ( link(Src,Dst) ) {
	     return (ERROR) ;}
    else
	     unlink(Src);

	/* Update Newfiles.dat in bbs dir */

	sprintf(Src, "%s/%s", SrcDir, NEWFILES);
	if (!access(Src, 0)) {
		sprintf(Dst, "%s/%s", DestDir, NEWFILES);
        unlink(Dst);
		if (link(Src, Dst))
			return (ERROR);
 		else
			unlink(Src);
	}
	/* Update Welcome file in bbs dir */

	sprintf(Src, "%s/%s", SrcDir, WELCOME);		/* try ascii mode */
	if (!access(Src, 0)) {
		sprintf(Dst, "%s/%s", DestDir, WELCOME);
        unlink(Dst);
		if (link(Src, Dst))
			return (ERROR);
	 	 else
			unlink(Src);
	}
	sprintf(Src, "%s/%s", SrcDir, WELCOMEG);	/* or ansi mode */
	if (!access(Src, 0)) {
		sprintf(Dst, "%s/%s", DestDir, WELCOMEG);
        unlink(Dst);
		if (fcopy(Src, Dst))
			return (ERROR);
		else
			unlink(Src);
	}
	/* Update News file in bbs dir */
	sprintf(Src, "%s/%s", SrcDir, NEWS);		/* try ascii mode */
	if (!access(Src, 0)) {
		sprintf(Dst, "%s/%s", DestDir, NEWS);
	    unlink(Dst);	
		if (link(Src, Dst))
			return (ERROR);

	} 
	sprintf(Src, "%s/%s", SrcDir, NEWSG);		/* or ansi mode */
	if (!access(Src, 0)) {
		sprintf(Dst, "%s/%s", DestDir, NEWSG);
        unlink(Dst);
		if (link(Src, Dst))
			return (ERROR);
		else 
   			unlink(Src);      	
   	}
	yellow();
	printf("%s...\n", txt[71]);	/* "adding msgs and creating indexes" */
	cyan();
	sprintf(Src, "%s/%s", SrcDir, MSG_FILE);	/* Open MESSAGES.DAT */

#ifdef __unix__
    printf("Open %s\n",Src);
	if ((fs = fopen(Src, "r")) == NULL)
#else
	if ((fs = fopen(Src, "rb")) == NULL)
#endif
	{
		printf("%s %s...\n", txt[51], Src);	/* "unable to open file" */
		return (ERROR);
	}
	if (setvbuf(fs, NULL, _IOFBF, VBUF))
		printf("%sMkIndex() [%s]\n", txt[94], Src);	/* "Setvbuf failed..." */

	/* Skip First Header      */
	if (!fread((char *) &Qmail.Status, 1, Head, fs)) {
		printf("%s %s\n", txt[58], Src);	/* "error reading file" */
		fclose(fs);
		return (ERROR);
	}
	/*
      This is where we read messages.dat the main message file from 
	  the BBS. The file is parsed into new seperate .cnf files for each
	  conference, each with its own index. While scanning the main file
	  we also look for a match between UserName (global variable) and
	  Qmail.ForWhom field in each message header. When a match is found
	  the message is also saved to a personal conference file with its 
	  own index, and a flag "persmail" is set which shows that personal 
	  mail has been received. Note that the index files sent in the QWK
	  packet are ignored and never used by this program.
   */	 
   
   /* Open personal conference and index files  */
	sprintf(Pdst, "%s/%d.cnf", DestDir, PERS_CONF );	/*--< Open Conference file >--*/

    if( OpenCon(&pfd, &fs, Pdst) == ERROR ) return (ERROR);

  	fseek(pfd, 0L, SEEK_END);	/* Go to end of personal idx file... */
  	plast = (long) ftell(pfd);	/* Take size of existing messages */
    plastold = plast ;
	sprintf(Pidx, "%s/%d.idx", DestDir, PERS_CONF);	/*--< Open Conference Index >--*/

   	if( OpenCon(&pfx, &fs, Pidx) == ERROR ) return(ERROR );
  	fseek(pfx, 0L, SEEK_END);
	pcount = (int) (ftell(pfx) / sizeof(struct MyIndex));

	while (1) {
		if (!fread(&Qmail.Status, 1, Head, fs))
			break;	/* End of file         */
		if (Qmail.MsgTime[2] != ':')
			break;	/* Dernier entete vide cree par les doors
				 * qmail probablement. */
		/* Faudrait tester un peu mieux que a... enfin...           */
		memcpy((char *) rbuf, (char *) &Qmail.Status, Head);
		if (readCnum(&(Qmail.BinConfN)) != conf) {	/* Another conference ? */
		    if(ffllgg) {     /* after first pass, close file pointers */ 	
		    	fclose(fx);	                        
				fclose(fd);	
			}
		    ffllgg = TRUE ;  /* first pass flag set true */	
			if (conf >= 0) {
			printf("Conference %d \t[ %-15s ]%c  %3d New %s %s\n",
				       ConfNumbers[iconf], ConfName[iconf], 
					   persmail?'*':' ' ,count - oldcount,
				       (count - oldcount) > 1 ? "Messages" : "Message",
					    persmail? txt[103] : " " );
			}
			persmail = FALSE ;	
			count = 0;
			oldcount = 0;
			conf = readCnum( &(Qmail.BinConfN) ) ;
			/* Open new files  */
			sprintf(Dst, "%s/%d.cnf", DestDir, conf);	/*--< Open Conference file >--*/
		    if( OpenCon(&fd, &fs, Dst) == ERROR ){
				fclose(pfx);fclose(pfd);
				return( ERROR );
			}

			fseek(fd, 0L, SEEK_END);	/* Go to end of file... */
			last = (long) ftell(fd);	/* Take size of existing messages */

			sprintf(Idx, "%s/%d.idx", DestDir, conf);	/*--< Open Conference Index >--*/
         	if( OpenCon(&fx, &fs, Idx) == ERROR ){
				fclose(pfx);fclose(pfd);	
				return(ERROR );
			}

			fseek(fx, 0L, SEEK_END);
			count = (int) (ftell(fx) / sizeof(struct MyIndex));
			oldcount = count;

			for (iconf = 0; conf != ConfNumbers[iconf]; iconf++); /* tgm   */

			printf("%d : %d\r", iconf, count - oldcount);	/* tgm      */
		}
        if( ! strnicmp( UserName, Qmail.ForWhom, NamLen )){
			pmail = TRUE ;    /* set global personal mail flag true */
			persmail = TRUE ; /* set local personal mail flag true  */
		}
		
		NbBlocs = atoi((char *) Qmail.SizeMsg) - 1;
		MaxChars = NbBlocs * 128;
		
		if (MaxChars > MYBUF) {
			printf("%s [ > %u bytes ]\n", txt[72], MYBUF);	/* "msg too big" */
			return (ERROR);
		}
		WriteIndex(fx, count, MaxChars, last);	/* Write Index Structure */
        count++ ; 
		if(persmail) {
			WriteIndex(pfx, pcount, MaxChars, plast); /* Write Personal Index */
            pcount++ ;
			}
		
		printf("%d : %d\r", iconf, count - oldcount);
		if (! fread((char *) (rbuf + Head), 1, MaxChars, fs)) {	/* Read the message..... */
            printf("max char %d\n",MaxChars);
		    printf("%s %s\n", txt[58], Src); /* "error reading file " */
			fclose(fs);
			fclose(fd); fclose(pfd);
			fclose(fx); fclose(pfx);
			return (ERROR);
		}
		ptr = (unsigned char *) (rbuf + Head);
		for (i = 0; i < MaxChars; i++) {	/* Translate to normal Line Feed */ 
			if (*ptr == 227)
				*ptr = '\n';
			ptr++;
		}
		while (*(--ptr) == 0x20)
			*ptr = 0;	/* delete padding spaces */
		if (!fwrite(rbuf, 1, MaxChars + Head, fd)) {	/* And copy it.         */
		 	printf("%s %s\n", txt[73], Dst);	/* "error writing file " */
			fclose(fs);
			fclose(fd); fclose(pfd);
			fclose(fx); fclose(pfx);
			return (ERROR);
		}
	    if(persmail) {
		    if (!fwrite(rbuf, 1, MaxChars + Head, pfd)) {	/* And copy it.         */
		 		printf("%s %s\n", txt[73], Dst);	/* "error writing file " */
				fclose(fs);
				fclose(fd); fclose(pfd);
				fclose(fx); fclose(pfx);
				return (ERROR);
			}
		plast+= (long) MaxChars + Head ;	
		}
		last += (long) MaxChars + Head;	/* INC counter... */
	} 	/* end of while(1) */
	if (conf >= 0) {
		printf("Conference %d \t[ %-15s ]%c  %3d New %s %s \n",
		       ConfNumbers[iconf], ConfName[iconf],
			    persmail?'*':' ',count - oldcount,	
		       (count - oldcount) > 1 ? "Messages" : "Message",
			     persmail ? txt[103] : " " );
	}
	printf("\n");
	fclose(fs); 
	fclose(fd); fclose(pfd); 
	fclose(fx); fclose(pfx);
    
	if( ! plast ) {      
         unlink(Pidx); /* if no personal messages, delete personal cnf. */	
         unlink(Pdst);
 	}	 

	ActvConf();  /* update array of active conferences */
}
	

/* *************************** end of MkIndex ******************************/
		 
/*
 * Add an index struct to the index file. 
 */
void 
WriteIndex(fx, count, Size, Offset)
	FILE           *fx;
	int             count;
	int             Size;
	long            Offset;
{
	Index.MsgNum = count;
	Index.Size = Size;
	Index.Offset = Offset;
	Index.LastRead = 0;

	if (!fwrite(&Index.LastRead, 1, sizeof(struct MyIndex), fx)) {
		printf("%s !\n", txt[74]);	/* "error writing index file
						 * " */
	}
}

/*  strip space on right side */

StripSpaceR(ptr)
	char           *ptr;
{
	while (*ptr == ' ') {
		*ptr = '\0';
		StripSpaceR(--ptr);
	}
}

/* strip space on left side */

StripSpaceL(ptr)
   char          *ptr ;
   {
	while(*ptr == ' ' ) 
		ShiftLeft(ptr,1);
   }


/*
	Open a .cnf or idx file for read/write

*/	
int OpenCon(FILE **pf, FILE **fs, char *dspath ) {

	if (access(dspath, 0)) {	/* Create if not exist */
		*pf = fopen(dspath, "w");
		fclose(*pf) ;
	}
#ifdef __unix__
	if ((*pf = fopen(dspath, "r+")) == NULL)
#else
	if ((*pf = fopen(dspath, "r+b")) == NULL)
#endif
	{
	printf("%s %s...\n", txt[51], dspath);	/* "unable to open file" */
    fclose(*fs);
	return (ERROR);
	}
	if (setvbuf(*pf, NULL, _IOFBF, VBUF))
		printf("%sMkIndex() [%s]\n", txt[94], dspath);	/* "Setvbuf failed..." */
}

int readCnum( char *ptr ) 
{
    unsigned char p, q;
	unsigned int j ;
	
	p = *ptr ;
	ptr++ ;
	q = *ptr ;
	q = q & 0x1f ;
    j = (unsigned int) q ;
	j <<=8 ; 
	j+= (unsigned int) p ;

	return(j) ;
}



/*
 * Update array tracking which conferences are active
 *
 */ 
 
 void ActvConf( void ) {
    extern int ActvCnt ;
	int             i, t;
	char            tmp[MAXPATHS];

 ActvCnt = 0 ;
 for (i = 0; i <= LastConf; i++) {

		sprintf(tmp, "%s%s/%d.cnf", HomePath, CurBoard, ConfNumbers[i]);
		if (! access(tmp, 0)) {
                       ConfActive[i] = TRUE ;
                       ActvCnt++ ;
		}			  
		else {
                       ConfActive[i] = FALSE ;	
		}
    }
}

