static char     rcsid[] = "$Id: read.c,v 1.30 1992/07/05 15:36:19 root Exp $";

/*
 * Change Log: $Log: read.c,v $
 * Revision 1.30  1992/07/05  15:36:19  root
 * first release of ATP
 *
 * Revision 1.2  1992/04/19  12:50:02  root 1st semifunctional UNIX version. 
 *
 */

/*
+--------------------------------------------------------------------------+
|                                                                          |
| ATP QWK Mail Reader for LINUX Copyleft and Copyright (c) 1992 KI4N TGM   |
|                                                                          |
|       Routines d'essai de reader au format Qmail - R.Cougnenc 90 -       |
|                                                                          |
|                      Small Reader for Qmail format.                      |
|                                                                          |
|        Using only tty mode and printf, this program should be compiled   |
|        on many systems with minor modifications.                         :
|                                                                          |
|                          Ren Cougnenc  1990                             |
|                                                                          |
+--------------------------------------------------------------------------+
*/
 
 #define my_mkdir(tmp2) mkdir(tmp2,S_IRWXU)
#ifdef LINUX
#include "pctolu.h"
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifdef __unix__
#include <unistd.h>
#else
#ifdef __TURBOC__
#include <alloc.h>
#else
#include <malloc.h>
#endif
#endif
#include "reader.h"
#include "qmail.h"
#include "ansi.h"
#include "system.h"
#include "read.h"
#include "readlib.h"
#include "makemail.h"

#define NEXT 1
#define AGAIN 0
#define PREVIOUS 2
#define SCAN 3

char           *TagLine = "\n---\n  ATP/Linux 1.3  ";	/* Reader Signature */
char           *FidoTag = "\n...\n * ATP/Linux 1.3 * ";	/* Fido Signature   */
char            CurTag[256];	/* Tag line chosen... */
char            UserTag[256];	/* Save run time defined tag-lines */
char            TmpTag[256];	/* Save run-time defined tag-lines */
char            OrigTag[256];	/* default tag from config */
int             dflag = TRUE;	/* toggle for default and user defined tagline*/
char           *taglist[TLLEN][80];	/* an array for holding taglines */

char            HomePath[MAXPATHS];	/* Home directory for exe file & root of msg dirs */
char            MailPath[MAXPATHS];	/* Where to look for new mail                    */
char            ReplyPath[MAXPATHS];	/* Where to put replies                          */
char            WorkPath[MAXPATHS];	/* Where to archive/unarchive mail .             */
char            qwklist[100];       /* command line for listing QWK packets */
char            CurBoard[50];	/* Name of the current board...                  */
int             CurConf;	/* Number of current Conference...               */
int             TotMsg;		/* Number of messages in conf                    */
int             fido = FALSE;	/* Flag for tagline style                        */

int             pmail = FALSE;	/* Flag indicates if personal mail waiting       */
int             ReplyExist = 0;	/* Flag 1 if there are replies to pack           */
int             ansi = 0;	/* Flag 1 if ansi output is on                   */
int             IsEmpty = TRUE;	/* Flag 0 if a BBS is loaded                     */
int             HeadLetter = 1;	/* Flag 1 if automatic header is active          */
int             SCREENLINES = 25;	/* default 25, changeable in config
					 * file         */
char            Editor[50];	/* Name of the standard text editor              */
char            Archiver[50];
char            UnArchiver[50];
void 
togltag(void);
struct MyIndex  Index;

FILE           *fidx = NULL,
               *fmsg = NULL ;	/* Index File and msg file, globals */
int             FilesOpen = FALSE;	/* Flag if these files are open     */
int             FirstDone  = FALSE;
int             ActvCnt = 0 ; /* tracks number of active conferences tgm */
byte           *rbuf;


/* System OS internal commands. Will be called by system directly from shell. */
#ifdef __unix__
#define MAXCMDS  14
static char    *cmds[MAXCMDS] = {"cd", "cp", "ls", "ln", "lpr", "sync",
			 "mkdir", "more", "pwd", "cwd", "rm", "rmdir", "set","cat"
};
#else
#define MAXCMDS  14
static char    *cmds[MAXCMDS] = {"cd", "chdir", "copy", "dir", "del", "era", "md",
			     "mkdir", "more", "print", "rd", "rmdir", "set",
				 "type"};
#endif

/*----------------------------------------------------------------------*/


main(argc, argv)
	int             argc;
	char           *argv[];
{
	MakeHomePath(argv[0]);
	if (ReadConfig())
		return (0xFF);

	Clean();
	clear();
	bblack();
	Title();

	cyan();

	strcpy(CurBoard, txt[10]);	/* First default prompt....   */
	strcpy(ConfName[0], txt[9]);	/* "empty"                    */
	if (fido)
		strcpy(CurTag, FidoTag);	/* setup the default TagLines */
	else
		strcpy(CurTag, TagLine);
	strcat(CurTag, OrigTag);

	if ((rbuf = (char *) malloc(MYBUF)) == NULL) {
		printf("%s\n", txt[1]);	/* Not enough memory */
		return (0xFF);
	}
	if (argc == 2)
		GetBbs(argv[1]);

	ReadShell();
	free(rbuf);
    if(FilesOpen){
		fclose(fidx);
		fclose(fmsg);
	}
	return (0);
}



/*
 * Main Shell 
 */

void 
ReadShell()
{
	char            tmp[256];
	char           *ptr;
	int             i , bnkflg = TRUE ; 

loop:

	while (1) {
        green();
        high(); 
        if( bnkflg && pmail && (CurConf == findCindex(PERS_CONF) )) {
			printf("%s [ ",CurBoard ) ; high(); blink();
			printf("%s", ConfName[CurConf] );
			clear(); green(); high(); printf(" ] > ") ;
	    }
		else {
			printf("%s [ %s ] > ", CurBoard, ConfName[CurConf]);
        }
		clear();
		gets(tmp);	/* get command line */

		StripDel(tmp);
		StripSpaceL(tmp);

		for (i = 0; i < MAXCMDS; i++) {	/* Internal shell commands */
			if (!strnicmp(tmp, cmds[i], strlen(cmds[i]))) {
				system(&tmp[0]);
				goto loop;
			}
		}

		if (Numeric(tmp))
			GoToNum(tmp);

		else if (!strnicmp(tmp, "aide", 4)) help();
		
		else if (!strnicmp(tmp, "cls", 3)) cls();
		
		else if (!strnicmp(tmp, "clean", 5)) Purge();
		
	 	else if (!strnicmp(tmp, "conf", 4)) ListConf();
		
		else if (!strnicmp(tmp, "date", 4)) Date();
		
		else if (!strnicmp(tmp, "help", 4)) help();
		
		else if (!strnicmp(tmp, "fido", 4)) togltag();
		
		else if (!strnicmp(tmp, "scan", 4)) scan();
		
		else if (!strnicmp(tmp, "ql",2)) Qlist(qwklist);
		
		else if (!strnicmp(tmp, "head", 4)) {
			blue();
			high();
			HeadLetter = HeadLetter ? 0 : 1;
			printf("%s ", txt[101]);	/* "Automatic H." */
			printf("%s\n", HeadLetter ? txt[85] : txt[86]);	/* "on" / "off"   */
		} 
		else if (!strnicmp(tmp, "news", 4)) {
			if (ansi) {
				sprintf(tmp, "%s%s/%s", HomePath, CurBoard, NEWSG);
				if (!access(tmp, 0)) {
					sprintf(tmp, "%s%s", HomePath, CurBoard);
					view(tmp, NEWSG);
					continue;
				}
			}
			sprintf(tmp, "%s%s", HomePath, CurBoard);
			view(tmp, NEWS);
		} 
		else if (!strnicmp(tmp, "time", 4)) Date();
		
		else if (!strnicmp(tmp, "welcome", 4)) Welcome();
		
		else if (!strnicmp(tmp, "file", 4)) {
			if (IsEmpty) {
				EmptyMsg();
				continue;
			}
			sprintf(tmp, "%s%s", HomePath, CurBoard);
			view(tmp, NEWFILES);
		} 
		else if (!strnicmp(tmp, "load", 4)) {
			    if( (! IsEmpty) && ConfActive[CurConf] )
			    	UpdateConf();
				load(tmp);  							/* Load new mail      */
             }
		else if (!strnicmp(tmp, "merde", 5)) merde();   /* Load new mail      */

		else if (!strnicmp(tmp, "rev", 3)){
			    if( (! IsEmpty) && ConfActive[CurConf] )
			    	UpdateConf();	             /* Save current conf pointer */
		        Read(tmp); /* read existing mail        */
		     }
		else if (!strnicmp(tmp, "tag", 3)) Tag(tmp);	/* change tagline     */

		else if (tmp[0] == '\0' || tmp[1] == '\0' || tmp[1] == '\040')
			switch ((int) tmp[0]) {
			case '?':
				help();
				break;

			case '!':
				if (tmp[1]) {
					system(&tmp[1]);
				} else {
#ifdef _unix_
					ptr = getenv("SHELL");
#else
					ptr = getenv("COMSPEC");
#endif
					if (ptr)
						system(ptr);
				}
				break;

			case 'a':
			case 'A':
                 if(FirstDone)         
		        	Display();
                 else             
                    ReadNext(NEXT); 
				 break;

			case 'e':
			case 'E':
				reply(ENTER, tmp);
				break;

			case 'j':
			case 'J':
				chconf(tmp);
				break;

			case 'm':	/* toggle ANSI mode on/off */
			case 'M':
				ansi = ansi ? 0 : 1;
				yellow();
				high();
				printf("%s %s .\n", txt[84], ansi ? txt[85] : txt[86]);
				break;

			case 'q':
			case 'Q':
			case 'g':
			case 'G':
			    if( ! IsEmpty )                         
			    	UpdateConf();	/* Save current conf pointer */
                if( FilesOpen ) {
					fclose(fidx);
					fclose(fmsg);
			        FilesOpen = FALSE ;	
				}
				if (ReplyExist) {
					red();
					high();
					printf("%s\n%s %s.\n", txt[2], txt[3], CurBoard);	/* Warning, you have  */
					printf("%s", txt[4]);	/* Replies,pack them ? */
					if (YesNo(YES))
						PackReply();
				}
				clear();
				return;

			case 'n':
			case 'N':
				AutoJoin();
				break;

			case 'r':
			case 'R':
	            if( ! tmp[1] && FirstDone )
			       reply(REPLY, tmp);
				break;

			case 's':
			case 'S':
				SaveMsg(tmp);
				break;

			case '+':
			case 0:
				ReadNext(NEXT);
				break;

			case '-':
				ReadNext(PREVIOUS);
				break;
			}
	}
}

void 
togltag(void)
{				/* switch tagline styles */
	fido = (fido ? FALSE : TRUE);
	Tag("tag \177");
}


void 
load(name)
	char           *name;
{
	char            BoardName[50];
	char            tmp3[MAXPATHS];
	char            tmp2[MAXPATHS];
	char            tmp[MAXPATHS];
	char            OldDat[MAXPATHS];
	char            NewDat[MAXPATHS];
	char           *tptr ;
	struct stat     Oldst;
	struct stat     Newst;
	int             i;

	pmail = FALSE;		/* reset global flag to indicate no personal mail yet */
	if (ReplyExist) {
		red();
		high();
		printf("%s\n%s %s.\n", txt[2], txt[3], CurBoard);	/* Warning, you have  */
		printf("%s", txt[4]);	/* Replies,pack them ? */
		if (YesNo(YES))
			PackReply();
        ReplyExist = FALSE ;	
	}
	BoardName[0] = '\0';
	sscanf(name, "%s %s", tmp, BoardName);
	if (!BoardName[0]) {
		red();
		printf("%s  %s\n", txt[87], txt[88]);	/* "usage" " load.." */
		return;
	}
	printf("%s %s\n", txt[5], BoardName);

	if (strstr(BoardName, ".qw") == NULL)
		strcat(BoardName, ".qwk");

	sprintf(tmp, "%s%s", MailPath, BoardName);
	/*
	 * Now that we've used BoardName to id the packet file strip any
	 * trailing digits so the board's subdir doesn't vary w/ packet #. 
	 */

	tptr = BoardName ;
	i = -1 ;
	while (BoardName[++i]);
	while (BoardName[--i] != '.');
	BoardName[i] = '\0';
    if(!Numeric(tptr))
		while (isdigit(BoardName[--i]))
			BoardName[i] = '\0';

	if (access(tmp, 0)) {
		red();
		printf("%s : %s\n", txt[6], tmp);	/* No mail found        */
		printf("%s\n", txt[7]);	/* Try the read command */
		return;
	}
	Clean();		/* Don't forget to clean work directory ! */
	yellow();
	high();
	printf("%s\n", txt[8]);	/* " Extracting Messages..." */
	green();
#ifdef __unix__
	if (getcwd(tmp3, sizeof(tmp3)) == NULL) ; 	/* save current directory    */
	chdir(WorkPath);                            /* change to work directory  */
	sprintf(tmp2, "%s %s", UnArchiver, tmp);    /* build unzip command line  */
	system(tmp2);                               /* execute unzip in work dir */
	chdir(tmp3);                                /* restore current directory */
#else
	sprintf(tmp2, "%s %s  %s %s %s %s? %s?  %s ",
		UnArchiver, tmp, CNTRL_FILE, MSG_FILE, NEWFILES, NEWS, WELCOME, WorkPath);
	system(tmp2);
#endif
	yellow();

	sprintf(tmp2, "%s%s", HomePath, BoardName);	/* Access to a board subdir*/
	if (access(tmp2, 0))
		my_mkdir(tmp2);

	sprintf(OldDat, "%s%s/%s", HomePath, BoardName, CNTRL_FILE);
	sprintf(NewDat, "%s/%s", WorkPath, CNTRL_FILE);
	if (stat(OldDat, &Oldst) != -1) {	/* If exists an old control.dat */
		stat(NewDat, &Newst);
		if (Newst.st_mtime <= Oldst.st_mtime) {
			red();
			high();
			printf("%s\n%s.\n", txt[2], txt[11]);	/* "New packet older..." */
			printf("%s...", txt[12]);	/* " Do you  want to.." */
			if (!YesNo(NO))
				return;
		}
	}
	strcpy(CurBoard, BoardName);
	MkIndex(WorkPath, tmp2);/* Create Index Files */
    if (FilesOpen) {
		fclose(fidx);
		fclose(fmsg);
		FilesOpen = FALSE ;
	}
	IsEmpty = FALSE ;
    CurConf = 0;
	if (pmail)
		GetConf(findCindex(PERS_CONF));
	else
		GetConf(0);	/* load  main board.  */
}



/*
 * Join a BBS without extracting new mail. 
 */
void 
Read(name)
	char           *name;
{
	char            BoardName[50];
	char            tmp[MAXPATHS];

	if (ReplyExist) {
		red();
		printf("%s\n%s %s.\n", txt[2], txt[3], CurBoard);	/* Warning, you have  */
		printf("%s", txt[4]);	/* Replies,pack them ? */
		if (YesNo(YES))
			PackReply();
        ReplyExist = FALSE ;	
	}
	BoardName[0] = 0;
	sscanf(name, "%s %s", tmp, BoardName);
	if (!BoardName[0]) {
		red();
		printf("%s %s\n", txt[87], txt[89]);	/* "usage " "read..." */
		return;
	}
	printf("%s %s\n", txt[5], BoardName);	/* "Loading" */

	sprintf(tmp, "%s%s", HomePath, BoardName);
	if (access(tmp, 0)) {
		printf("%s : %s\n", txt[13], tmp);	/* "No bbs found " */
		return;
	}
	if (ReadControl(tmp)) {
		printf("%s\n", txt[14]);	/* "Error in CONTROL.DAT." */
		return;
	}
    if (FilesOpen) {
		fclose(fidx);
		fclose(fmsg);
		FilesOpen = FALSE ;
	}
	strcpy(CurBoard, BoardName);
    ActvConf();    /* update boolean array of active/inactive flags */
	IsEmpty = FALSE; 
	CurConf = 0;
	GetConf(0);
}




/*
 * CHCONF : Change active conference. 
 */
void 
chconf(buf)
	char           *buf;
{
	char            Name[50];
	char            tmp[MAXPATHS];
	int             i, m;

	if (IsEmpty) {
		EmptyMsg();
		return;
	}
	Name[0] = 0;
	sscanf(buf, "%s %s", tmp, Name);
	if (!Name[0]) {
		red();
		printf("%s\n", txt[87]);	/* "Usage" */
		printf("\tj %s\n\t\t%s\n", txt[90], txt[91]);	/* "Conf #" "or" */
		printf("\tj %s\n", txt[92]);	/* "conf name" */
		printf("%s\n", txt[93]);	/* "type conf to list..." */
		return;
	}
	if (Numeric(Name)) {	/* a number is given */
		i = atoi(Name);
		if ((i = findCindex(i)) > -1)
			strcpy(Name, ConfName[i]);
	} else {		/* a name is given   */
        m = strlen(Name);
		for (i = 0; i <= LastConf; i++) {
			if (!strnicmp( Name, ConfName[i], m))
				break;
		}
	}

	if (!strnicmp(Name, "MAIN", 4))
		i = 0;		/* Special case for "main board" */

	if (i > LastConf || i < 0) {
		printf("\n%s\n", txt[28]);	/* "Unknown conference" */
		return;
	}
	sprintf(tmp, "%s%s/%d.cnf", HomePath, CurBoard, ConfNumbers[i]);
	if (access(tmp, 0)) {
		red();
		printf("%s : %s\n", txt[6], tmp);	/* "No mail found" */
		return;
	}
	UpdateConf();		/* Save current conf pointer */
    if(	GetConf(i) == ERROR)
	    return;
	blue();
	high();
	printf("\n *  %s %s %s. *\n\n", txt[29], ConfName[CurConf], txt[30]);
	/* "Conference " "joined" */
}




/*
 * Loads next valid conferences. 
 */
void 
AutoJoin()
{
	static char    *Default = "j MAIN\n";
	char            tmp[MAXPATHS];
	int             i, j;

	if (IsEmpty) {
		EmptyMsg();
		return;
	}
	i = CurConf;
	j = LastConf;
	while (i < j) {
		i++;
		sprintf(tmp, "%s%s/%d.cnf", HomePath, CurBoard, ConfNumbers[i]);
		if (!access(tmp, 0)) {
			sprintf(tmp, "j %d\n", ConfNumbers[i]);
			chconf(tmp);
			if (Index.LastRead == TotMsg - 1) {
				printf("\t%s.\n", txt[31]);	/* "No new mail" */
				continue;
			}
			return;
		}
	}
	chconf(Default);	/* Default to Main Board. */
}


/*
 * Save current message in text file ( append mode ). 
 */

void 
SaveMsg(str)
	char           *str;
{
	char            dummy[50];
	char            fname[MAXPATHS];
	char           *ptr;
	FILE           *fp;
	int             i, apflag;

	if (IsEmpty) {
		EmptyMsg();
		return;
	}
	fname[0] = 0;
	sscanf(str, "%s %s", dummy, fname);
	if (!fname[0]) {
		high();
		yellow();
		printf("%s : ", txt[39]);	/* "save message in file" */
		clear();
		fget(fname, 12, stdin);
		if (!fname[0]) {
			printf("%s.\n", txt[40]);	/* "Aborted" */
			return;
		}
	}
	apflag = access(fname, 0) ? 1 : 0;

	if ((fp = fopen(fname, "a")) == NULL) {
		red();
		high();
		printf("%s %s\n", txt[51], fname);	/* "unable to open file" */
		return;
	}
	if (setvbuf(fp, NULL, _IOFBF, VBUF))
		printf("%sSavemsg()\n", txt[94]);	/* "Setvbuf failed..." */

	PrintHeader(fp);

	ptr = (char *) (rbuf + sizeof(struct MsgHeaderType));
	i = 0;
	while (i < Index.Size) {
		if (*ptr != 0)
			fputc(*ptr, fp);
		i++;
		ptr++;
	}

	fprintf(fp, "\n");

	blue();
	high();
	/* printf("Message %s",apflag ? "Saved in" : "Appended to"); */
	printf("%s %s", txt[41], apflag ? txt[42] : txt[43]);
	clear();
	cyan();
	printf(" %s\n", fname);
	fclose(fp);
}




/*
 * Help message. 
 */

void 
help()
{
	int             i;

	white();
	high();
	printf("\n%s", hlp[1]);
	clear();
	printf("\n");
	for (i = 0; i < strlen(hlp[1]); i++)
		putchar('-');
	printf("\n");
	high();
	printf("\r\t q,g\t%s\n", hlp[2]);
	printf("\t ?\t%s\n", hlp[3]);
	printf("\t !\t%s\n", hlp[4]);
	printf("\t +\t%s\n", hlp[5]);
	printf("\t -\t%s\n", hlp[6]);
	printf("\t a\t%s\n", hlp[7]);
	printf("\t e\t%s\n", hlp[8]);
	printf("\t j\t%s\n", hlp[9]);
	printf("\t m\t%s\n", hlp[10]);
	printf("\t n\t%s\n", hlp[11]);
	printf("\t r\t%s\n", hlp[12]);
	printf("\t s\t%s\n", hlp[13]);
	printf("\t conf\t%s\n", hlp[14]);
	printf("\t clean\t%s\n", hlp[15]);
	printf("\t load\t%s\n", hlp[16]);
#ifdef ENGLISH
	printf("\t review\t%s\n", hlp[17]);
#else
    printf("\t revois\t%s\n", hlp[17]); 
#endif
	printf("\t files\t%s\n", hlp[18]);
	printf("\t tag\t%s\n", hlp[19]);
	printf("\t head\t%s\n", hlp[22]);
	printf("\t scan\t%s\n", hlp[24]);
	printf("\t qlist\t%s\n", hlp[23]);
	printf("\n");
}



/*
 * Change Reader Signature :-) 
 */
void 
Tag(line)
	char           *line;
{
	byte            dummy[50];
	byte            tmp[256];
	byte            tmp2[256];
	byte           *ptr;
	extern int      dflag;
	int             i;
	tmp2[0] = tmp[0] = 0;

	sscanf(line, "%s %s %s", dummy, tmp, tmp2);

	if (tmp2[0] == 0 && (strnicmp(tmp, "list", 4) == 0)) {	/* list taglines */
		cyan();
		high();
		printf("\n\tCurrent TagLines are:\n\n");
		for (i = 0; i < TLLEN; i++)
			printf("%2d: %s", i, &(taglist[i][0]));
		printf("\nDefault Tag : %s", OrigTag);
		printf("User defined: %s", UserTag);
		printf("\n");
		return;
	}
	if (tmp2[0] == 0 && Numeric(tmp)) {	/* try to get a tagline from
						 * the list */
		i = atoi(tmp);
		i = i < 0 ? -i : i;
		if (i < TLLEN)
			strcpy(TmpTag, &(taglist[i][0]));
		else
			return;
		if (fido)
			strcpy(CurTag, FidoTag);
		else
			strcpy(CurTag, TagLine);
		strcat(CurTag, TmpTag);
		printf("Current Tag now set to:");
		printf("%s\n", CurTag);
		return;
	}
	if (tmp[0] == 0) {	/* restore standard tag */
		dflag = dflag ? FALSE : TRUE;

		if (fido)
			strcpy(CurTag, FidoTag);
		else
			strcpy(CurTag, TagLine);
		if (dflag)
			strcat(CurTag, OrigTag);
		else
			strcat(CurTag, UserTag);

		printf("Current Tag now set to:");
		printf("%s\n", CurTag);
		return;
	}
	if (tmp[0] == '?') {	/* Print current tag */
		printf("Current TagLine is:");
		printf("%s\n", CurTag);
		return;
	}
	if (tmp[0] == '\177') {	/* toggle fido tag */
		strcpy(tmp, CurTag);
		if (fido) {
			line = tmp + strlen(TagLine);	/* point to start of tag
							 * message */
			strcpy(CurTag, FidoTag);
		} else {
			line = tmp + strlen(FidoTag);
			strcpy(CurTag, TagLine);
		}
		strcat(CurTag, line);
	} else {
		line += 4;	/* Change current tag to User defined Tag */
		strcpy(UserTag, line);
		strcat(UserTag, "\n");
		if (fido)
			strcpy(CurTag, FidoTag);
		else
			strcpy(CurTag, TagLine);
		strcat(CurTag, UserTag);
		dflag = FALSE;
	}
	printf("Tag is now set to :");
	printf("%s\n", CurTag);

}





/*
 * Print Next,previous or current message. 
 */

int 
ReadNext(mode)
	int             mode;
{
	int             Head = sizeof(struct MsgHeaderType);
	long            here;

	if (IsEmpty) {
		EmptyMsg();
		return(0);
	}

	if( ! FilesOpen ) {
		printf("%s \n",txt[44] ); /* no mail in conf */
        if(mode = SCAN)
		   return(0) ;
		else   
		   AutoJoin(); 
		return(0);
	}

	if (mode == PREVIOUS) {
		here = ftell(fidx) - (long) (2 * sizeof(struct MyIndex));
		if (here < 0L) {
			printf("%s\n", txt[15]);	/* "First message !" */
			return(0);
		}
		if (fseek(fidx, here, SEEK_SET)) {
			printf("%s.\n", txt[16]);	/* "Seek error" */
			return(0);
		}
	}
	if (fread(&Index.LastRead, 1, sizeof(struct MyIndex), fidx)
	    != sizeof(struct MyIndex)) {
		printf("%s\n", txt[17]);	/* "End of messages." */
        if( mode == SCAN )
		     return(0);
		 else
		     AutoJoin();
		return(0);
	}
	if (fseek(fmsg, Index.Offset, SEEK_SET)) {
		printf("%s!\n", txt[16]);	/* "Seek Error" */
		return(0);
	}
	if ((fread((char *) rbuf, 1, Index.Size + Head, fmsg)) != Index.Size + Head) {
		printf("%s? \n", txt[18]);	/* Read Error */
		return(0);
	}
	if (mode == SCAN)
		PutHeader();
	else
		Display();
	return(-1);        
}




/*
 * Prints the Qmail message header pointed by buf . 
 */

void 
PutHeader()
{
	struct MsgHeaderType *Header;
	static byte    *Space = "\t\t";

	Header = (struct MsgHeaderType *) rbuf;

	/* First line */
	high();
	green();
	printf("\n%s", txt[19]);/* " From :" */
	yellow();
	nprint(Header->Author, 25);
	printf(Space);
	green();
	printf("%s", txt[23]);	/* "Number" */
	yellow();
	nprint(Header->NumMsg, 7);

	/* Second line */
	green();
	printf("\n%s", txt[20]);/* "To:" */
	red();
	if (!strnicmp(UserName, Header->ForWhom, strlen(UserName)))
		blink();
	nprint(Header->ForWhom, 25);
	printf(Space);

	clear();
	green();
	high();
	printf("%s", txt[24]);	/* " Ref # " */
	red();
	nprint(Header->RefMsg, 7);

	green();
	printf("\n%s", txt[21]);/* "Subject" */
	cyan();
	nprint(Header->Subject, 25);
	printf(Space);
	green();
	printf("%s", txt[25]);	/* "Conf : " */
	magenta();
	printf("%s", ConfName[findCindex(readCnum(&(Header->BinConfN)))]);	
	green();
	printf("\n%s", txt[22]);/* "date:" */
	red();
	nprint(Header->MsgDate, 8);
	green();
	printf("%s", txt[26]);	/* "time:" */
	red();
	nprint(Header->MsgTime, 5);
	clear();
	blue();
	printf("\t[%d/%d]", Index.MsgNum + 1, TotMsg);	/* 0 based, print 1
							 * based. */
	if (Header->Status == '+' || Header->Status == '*') {
		printf("\t\t");
		red();
		high();
		printf(" %s%c\n", txt[27], 7);	/* "PRIVATE MESSAGE" */
	}
	printf("\n\n");
	clear();
	cyan();
}


/*
 * Prints the Qmail message header in file fp. 
 */

void 
PrintHeader(fp)
	FILE           *fp;
{
	struct MsgHeaderType *Header;
	static byte    *Space = "\t\t";

	Header = (struct MsgHeaderType *) rbuf;

	/* First line */
	fprintf(fp, "\n%s", txt[19]);	/* "from:" */
	nfprint(fp, Header->Author, 25);
	fprintf(fp, Space);
	fprintf(fp, "%s", txt[23]);	/* "number:" */
	nfprint(fp, Header->NumMsg, 7);

	/* Second line */
	fprintf(fp, "\n%s", txt[20]);	/* "to :" */
	nfprint(fp, Header->ForWhom, 25);
	fprintf(fp, Space);
	fprintf(fp, "%s", txt[24]);	/* "ref#" */
	nfprint(fp, Header->RefMsg, 7);

	fprintf(fp, "\n%s", txt[21]);	/* "subj." */
	nfprint(fp, Header->Subject, 25);
	fprintf(fp, Space);
	fprintf(fp, "%s", txt[25]);	/* "Conf : " */
	fprintf(fp, "%s", ConfName[findCindex(readCnum(&(Header->BinConfN)))]);
	fprintf(fp, "\n%s", txt[22]);	/* "date :" */
	nfprint(fp, Header->MsgDate, 8);
	fprintf(fp, "%s", txt[26]);	/* "time:" */
	nfprint(fp, Header->MsgTime, 5);
	fprintf(fp, "\t[%d/%d]", Index.MsgNum + 1, TotMsg);	/* 0 based, print 1
								 * based. */
	if (Header->Status == '+' || Header->Status == '*') {
		fprintf(fp, "\t\t");
		fprintf(fp, "  %s\n", txt[27]);	/* "PRIVATE MESSAGE" */
	}
	fprintf(fp, "\n\n");
}





/*
 * Reply to current message or enter a message
 * ------------------------------------------- 
 */
void 
reply(mode, line)
	int             mode;
	char           *line;
{
	int             i,j;
	char            fname[MAXPATHS];
	char            cmd[MAXPATHS];
	char            tmp[MAXPATHS];
	char            dummy[MAXPATHS];
	char           *tmp2;
	int             reedit = FALSE;
	struct MsgHeaderType *Header;
	struct QmailRepType Qmail;
	static int      SaveConf;	/* save current conference */

	SaveConf = CurConf;
	if (IsEmpty) {
		EmptyMsg();
		return;
	}

	if (mode == ENTER  ) {
		if( (sscanf(line, "%s %s", dummy, tmp))==2 ) {
			if (Numeric(tmp)) {
			   	i = atoi(tmp);
                i = findCindex(i);
                printf("%d is i\n",i); 
        	} else {                                /* not numeric */
				if (!strnicmp(tmp, "MAIN", 4))
					i = 0;
				else {
			        j = strlen(tmp);	
					for (i = 0; i <= LastConf; i++)
						if (!strnicmp(tmp, ConfName[i],j)) 
					                       break ; 	
				}
			}
            if( i<0 || i>LastConf ) {
				printf("\n%s\n", txt[28]);	/* Unknown Conference */
				return;
			}
            CurConf = i ;
       }  
	   if( CurConf == findCindex(PERS_CONF))
                    return; 
	   printf("\n%s %d  %s %s\n", txt[29], ConfNumbers[CurConf],
	         ConfName[CurConf], txt[30]);
 }
	Header = (struct MsgHeaderType *) rbuf;

	if (SaveConf == findCindex(PERS_CONF))	/* get actual conf. from header */
		CurConf = findCindex(readCnum(&(Header->BinConfN)));

	sprintf(fname, "%s/reply.tmp", WorkPath);	/* Temporary file */
	sprintf(cmd, "%s %s", Editor, fname);	/* Editor command */

l_edit:			/* this is wher we go if we need to re-edit
				 * msg. */

	ResetHeader(&Qmail);

moreto:
	green();
	scpy(dummy, Header->Author, 25);
	printf("       To [ %-25s ] : ", (mode == REPLY) ? dummy : "ALL");
	white();
	left(30);
	printf("");
	fget(tmp, 50, stdin);
	StripDel(tmp);
	if (tmp[0]) {
		if (!stricmp(tmp, "N")) {
			blue();
			printf("%s.\n", txt[33]);	/* "message aborted" */
            CurConf = SaveConf ; 
			return;
		}
		if (strlen(tmp) > 25) {
			red();
			printf("%s\n", txt[34]);	/* "Entry too long ! 25 chars max */
			goto moreto;
		}
		str2mem(Qmail.ForWhom, tmp);
	} else
		str2mem(Qmail.ForWhom, (mode == REPLY) ? dummy : "ALL");


moresub:

	green();
	scpy(dummy, Header->Subject, 25);
	printf("  Subject [ %-25s ] : ", (mode == REPLY) ? dummy : "");
	white();
	left(30);
	printf;
	fget(tmp, 50, stdin);
	StripDel(tmp);
	if (!strcmp(tmp, "N") || !strcmp(tmp, "n")) {
		blue();
		printf("%s.\n", txt[33]);	/* "message aborted" */
        CurConf=SaveConf ;
		return;
	}
	if (tmp[0]) {
		if (strlen(tmp) > 25) {
			red();
			printf("%s\n", txt[34]);	/* "Entry too long ! 25 chars max */
			goto moresub;
		}
		str2mem(Qmail.Subject, tmp);
	} else
		str2mem(Qmail.Subject, (mode == REPLY) ? dummy : "*");

moresec:
	green();
	if (mode == REPLY)
		printf(" Security [ %-25s ] : ",
		 (Header->Status == '+') ? "R (private)" : "None (public)");
	else
		printf(" Security [ %-25s ] : ", "None (public)");
	white();
	left(30);
	printf;
	fget(tmp, 50, stdin);
	StripDel(tmp);
	if (tmp[0]) {
		strupr(tmp);
		if (strlen(tmp) > 2) {
			red();
			printf("%s\n", txt[35]);	/* "Too long!
							 * R=...etc..." */
			goto moresec;
		}
		if (tmp[0] == 'R') {
			Qmail.Status = 0x2A;
			blink();/* green(); */
			up(1);
			right(12);
			printf("");
			printf("%s", txt[36]);	/* "Receiver only" */
			clear();
			printf("");
		}
	}
	/* Default selection  */
	else if (Header->Status == '+' || Header->Status == '*') {
		Qmail.Status = 0x2A;
		blink();	/* green(); */
		up(1);
		right(12);
		printf("");
		printf("%s", txt[36]);	/* "Receiver only" */
		clear();
		printf("");
	}
	str2mem(Qmail.Author, UserName);   /* Right name in the from field */
	sprintf(dummy, "%-7d", ConfNumbers[CurConf]);
	str2mem(Qmail.ConfNum, dummy);	/* Msg goes to the current conference */

	scpy(dummy, Header->NumMsg, 7);
	str2mem(Qmail.RefMsg, (mode == REPLY) ? dummy : "");
	printf("\n\n\n\n");

	if (mode == REPLY && reedit == FALSE)
		QuoteMsg(fname);/* Quote original message... */
	white();
	printf("%s\n", txt[38]);/* "calling editor" */
	printf("%s \n", cmd);
	system(cmd);		/* Edit message....          */

	/* Here is where we ask if we want to save message */

    Tag("tag ?");
    printf("Fido style tagline is %s.\n\n", fido? "ON" : "OFF" );
    printf("select:\n\t`Save' to save reply.\n"); 
	printf("\t`Edit' to re-edit reply.\n"); 
	printf("\t`Fido' to toggle tagline style and save reply.\n") ;
    printf("\t`Abort' to cancel reply.\n\n") ; 	
	printf("Choose: Save, Edit, Fido, Abort ?  S\b");
	gets(tmp);
	StripDel(tmp);
	tolower(tmp[0]);
	if (tmp[0] == 'e') {
		reedit = TRUE;
		goto l_edit;
	}			/* re-edit message */
	if (tmp[0] != 's' && tmp[0] != '\0' && tmp[0] !='f' ) {	/* abort reply */
		printf("\n\n%s\n", txt[33]);
		unlink(fname);
        CurConf = SaveConf ;	
		return;
	}
    if(tmp[0]=='f') {
		togltag();
	}
	
    if( ! fido )                   /* adjust header for fido or not */
	   for( i = 0; i<50 ; i++ )
	        Qmail.ForWhom[i] = toupper(Qmail.ForWhom[i]) ;

Qmail.ForWhom[74] = 0 ;
printf("%s\n",Qmail.ForWhom) ;
	AddReply(fname, (struct QmailRepType *) & Qmail.Status);
    CurConf = SaveConf;

}




/*
 * Add the reply to a Qmail reply.msg file. 
 */
void 
AddReply(fname, Qmail)
	char           *fname;
	struct QmailRepType *Qmail;
{
	OpenRepFile();
	if (CodeMessage(fname, Qmail))
		return;
	ReplyExist = 1;
}




/*
 * LIST CONF : Prints conferences numbers,names, and status. 
 */

void 
ListConf()
{
	int             i, line, t, pers = TRUE;
	char            tmp[MAXPATHS];

	if (IsEmpty) {
		EmptyMsg();
		return;
	}
	cls();
	magenta();
	high();
	printf("\r%s %s\n", txt[78], BoardName);	/* "Liste des conf. sur" */
	clear();
	red();
	printf("\r");
	for (i = 0; i < (strlen(txt[78]) + strlen(BoardName) + 1); i++)
		putchar('-');
	putchar('\n');

	for (i = 0, line = 0; i < LastConf; i++) {
		line++;
		if (line > SCREENLINES - 5) {
			line = 0;
			printf("\n");
			if (!more(YES))
				break;
			cyan();
		}
		if (pers) {		/* List personal conference first */
            if(pmail) blink();
			i = LastConf;
		} 

		sprintf(tmp, "%s%s/%d.cnf", HomePath, CurBoard, ConfNumbers[i]);
		red();
		high();
		printf("\n\t\t%4d ", ConfNumbers[i]);
		clear();
		blue();
		printf("......... ");
		magenta();
        if(pers && pmail) blink(); 
		high();
		printf("%-15s ", ConfName[i]);
		clear();
		blue();
		printf("......... ");
        if(pers && pmail) blink();
		high();
		if (access(tmp, 0)) {
			printf("%s", txt[79]);	/* "Inactive" */
		} else {
			magenta();
			printf("%s", txt[80]);	/* "active" */
		}
        if(pers){
			i = -1 ;
			pers = FALSE ; 
            clear();       
		}
    }
	clear();
    printf("\n\n");
}


/*
 * Goes to the msg number represented by the string. and print it. ( Internal
 * count, not BBS numbers ! ) 
 */
void 
GoToNum(str)
	char           *str;
{
	int             nb;
	int             Head = sizeof(struct MsgHeaderType);
	struct MyIndex  tmpidx;

	if (IsEmpty) {
		EmptyMsg();
		return;
	}
	nb = atoi(str);
	nb--;
	if (nb < 0 || nb > TotMsg) {
		red();
		high();
		printf("%s\n", txt[81]);	/* "Number out of range ! " */
		printf("%s ", txt[82]);	/* "Valid msgs are" */
		magenta();
		printf("1 ");
		red();
		printf("%s ", txt[83]);	/* "to" */
		magenta();
		printf("%d\n", TotMsg);
		return;
	}
	if (fseek(fidx, (long) nb * (long) sizeof(struct MyIndex), SEEK_SET)) {
		printf("%s !\n", txt[16]);	/* "seek error" */
		return;
	}
	if (fread(&Index.LastRead, 1, sizeof(struct MyIndex), fidx)
	    != sizeof(struct MyIndex)) {
		printf("%s\n", txt[17]);	/* "End of messages " */
	}
	if (fseek(fmsg, Index.Offset, SEEK_SET)) {
		printf("%s !\n", txt[16]);
		return;
	}
	if ((fread((char *) rbuf, 1, Index.Size + Head, fmsg)) != Index.Size + Head) {
		printf("%s ? \n", txt[18]);	/* "read error" */
		return;
	}

	Display();

}



/*
 * DISPLAY : Prints the current message,stored in memory. 
 */
void 
Display()
{
	int             line;
	unsigned        i;
	register int    count;
	int             QuotedColor;
	unsigned char  *ptr, *pt;
	char            tmp[MAXPATHS];

	if (IsEmpty) {
		EmptyMsg();
		return;
	}
	cls();
	PutHeader();
	cyan();
	line = 0;
	i = 0;
	count = 0;

	ptr = (char *) (rbuf + sizeof(struct MsgHeaderType));
	i = 0;
	line = 0;
	QuotedColor = 0;
	pt = tmp;
	*pt = 0;

	while (i < Index.Size) {
		if (count > MAXPATHS - 1)	/* Security for long lines       */
			*ptr = '\n';

		if (*ptr == '\n') {	/* Display a total line          */
			count = 0;
			*pt = 0;
			line++;
			pt = tmp;
			if (IsQuoted('>', pt)) {	/* Process colors on quoted line */
				while (*pt != '>')
					putchar(*pt++);
				QuotedColor = 1;
				red();					/* Quote char in red... */
				putchar(*pt++);
				green();				/* Quoted line in green.. */
				puts(pt);
				cyan();
				pt = tmp;
			} else {
				if (QuotedColor) {
					cyan();
					QuotedColor = 0;
				}
				puts(tmp);
			}
		} else {
			if (*ptr) {	/* Non 0 chars */
#ifdef LINUX
	/*  translate DOS to LINUX extended ASCII character set */

				*pt = codelu[(unsigned) (*ptr)];	/* use lookup table */
#else
				*pt = *ptr;
#endif
				pt++;
				count++;	/* Security for line length ... */
			}
		}

		i++;
		ptr++;

		if (line > SCREENLINES - 8) {
			line = 0;
			if (!more(YES))
				break;
			cyan();
		}
	}
	printf("\n");
    FirstDone = TRUE ;
}



/*
 * Welcome : Displays the welcome file. 
 */
void 
Welcome(void)
{
	char            tmp[MAXPATHS];

	if (ansi) {
		sprintf(tmp, "%s%s/%s", HomePath, CurBoard, WELCOMEG);
		if (!access(tmp, 0)) {
			sprintf(tmp, "%s%s", HomePath, CurBoard);
			view(tmp, WELCOMEG);
			return;
		}
	}
	sprintf(tmp, "%s%s/%s", HomePath, CurBoard, WELCOME);
	if (!access(tmp, 0))
		sprintf(tmp, "%s%s", HomePath, CurBoard);
	view(tmp, WELCOME);
}

/*
 * GETBBS : Called by main() with argv[1]. Looks for a new QWK packet, if
 * older than message base, just  loads the base. 
 */

void 
GetBbs(name)
	char           *name;
{
	char            tmp[MAXPATHS];
	char            packet[MAXPATHS];
	char            base[MAXPATHS];
	struct stat     Oldst;
	struct stat     Newst;

	strcpy(tmp, name);
	if (strstr(name, ".qw") == NULL)
		strcat(tmp, ".qwk");

	sprintf(packet, "%s%s", MailPath, tmp);

	if (access(packet, 0)) {/* No new mail found */
		printf("%s\n", txt[31]);	/* "no new mail" */
		Read(name);
		return;
	}
	sprintf(base, "%s%s/%s", HomePath, name, CNTRL_FILE);
	if (access(base, 0)) {
		printf("%s. ", txt[45]);	/* New BBS in this base. */
		sprintf(tmp, "load %s", name);
		load(tmp);
		return;
	}
	stat(packet, &Newst);
	stat(base, &Oldst);

	if (Newst.st_mtime <= Oldst.st_mtime) {
		blue();
		high();
		printf("%s. %s.\n", txt[46], txt[47]);
		sprintf(tmp, "read %s", name);
		Read(tmp);
		return;
	}
	sprintf(tmp, "load %s", name);
	load(tmp);
}


void 
Purge()
{
	int             i;
	char            tmp[80];
	char            cnf[MAXPATHS];
	char            idx[MAXPATHS];
	struct stat     st;

	if (IsEmpty) {
		EmptyMsg();
		return;
	}
	magenta();
	high();			/* Selective erasing of conferences. */
	printf("\n%s\n", txt[102]);	/* Effacement slectif des
					 * confrences */
	clear();
	red();
	printf("----------------------------------------\n\n");

	for (i = 0; i <= LastConf; i++) {
		sprintf(cnf, "%s%s/%d.cnf", HomePath, CurBoard, ConfNumbers[i]);
		sprintf(idx, "%s%s/%d.idx", HomePath, CurBoard, ConfNumbers[i]);

		if (stat(cnf, &st) == -1)
			continue;	/* No such file */

onemore:

		green();
		high();
		printf("Conf. %d [ ", ConfNumbers[i]);
		yellow();
		printf("%s", ConfName[i]);
		green();
		printf(" ] takes ");
		yellow();
		printf("%ld", st.st_size);
		green();
		printf(" bytes. Delete (Y)es (N)o (S)top : ");

		fget(tmp, 5, stdin);
		strupr(tmp);

		switch ((int) tmp[0]) {
		case 'N':
			break;

		case 'S':
			return;

		case 'Y':
		case 'O':
		case 'J':
			if (unlink(cnf) == -1)
				printf("Unable to remove file %s\n", cnf);
			if (unlink(idx) == -1)
				printf("Unable to remove file %s\n", idx);
			blue();
			if (i == CurConf) {
				Index.LastRead = 0;
				Index.MsgNum = 0;
				TotMsg = 0;
                if(FilesOpen){
					fclose(fidx);
					fclose(fmsg);
					FilesOpen = FALSE ;
                    FirstDone = FALSE ;
				}
			}
            ConfActive[i] = FALSE ;
			printf("Conference %d is now empty.\n\n", ConfNumbers[i]);
            ActvCnt-- ;  /* one less active conference */
			
			break;

		default:
			goto onemore;
		}
	}
}

/* scan through the message headers */

int 
scan(void)
{

	int             i, m;

	m = SCREENLINES / 6;
	do {
		cls();
		for (i = 0; i < m; i++)
			if( ! ReadNext(SCAN))
			    return(0);
	}
	while (more(YES));
return(-1) ;
};

#ifdef BSD
#include "atp-BSD.c"
#endif

