/*
                                READER.H
*/

#define SEP    '/'       /* File path separator */
#define SEPDOS '\\'
#define ERROR     1
#define OK        0
#define EOS       0       /* End of string */

#define CONFIG_FILE "atprc"
#define WORK_DIR    "work"
#define SCREENLINES  screenlen 

#define __LARGE__
/*===== Size limits . & memory model dependances =========================*/

#ifdef __SMALL__

#define _SMALL_MODEL_
#define MAXCONF       50   /* Increase if you need more conferences       */
#define NAMCONF       15   /* Max name length                             */
#define MYBUF      15000   /* MAX message len .(buffer ) RECEIVED MESSAGE */
#define MAXSIZE    15000   /* MAX message len  (buffer ) SENDED   MESSAGE */
                           /* (32000 = about 400 lines with 80 chars/line)*/
#define VBUF       5144    /* I/O buffers for setvbuf()                   */
#define MAXPATHS    127    /* File names                                  */
#endif

#ifdef __LARGE__

#define _LARGE_MODEL_
#define MAXCONF     1001   /* Can not exceed 8191 but could be less.      */
#define NAMCONF       15   /* Max name length                             */
#define MYBUF      32000   /* MAX message len .(buffer ) RECEIVED MESSAGE */
#define MAXSIZE    32000   /* MAX message len  (buffer ) SENDED   MESSAGE */
                           /* (32000 = about 400 lines with 80 chars/line)*/
#define VBUF       10240   /* I/O buffers for setvbuf()                   */
#define MAXPATHS    127    /* File names                                  */
#endif

#ifndef _SMALL_MODEL_
#ifndef _LARGE_MODEL_
#error "Must compile in small or large memory model."
#endif
#endif

#ifndef __DISTRIB__
#define __DISTRIB__ 1
#endif
/*------------------------------------------------------------------------*/

#define REPLY     0
#define ENTER     1

#define YES 1
#define NO  0



#ifndef BYTE_DECL
typedef unsigned char byte ;
#define BYTE_DECL
#endif


/* typedef */
struct  MyIndex {
         
            int LastRead  ;    /* Last Message Read, Used once...            */
            int MaxMsg    ;    /* Max Messages allowed in conf. (future use) */
            int MsgNum    ;    /* Number of This message                     */
            long Offset   ;    /* Offset in the Conference file              */
            unsigned Size ;    /* Size of the message,with Header            */
        }  ;

/* The last read field is only used in the first structure of the file ...   */

extern char *TagLine;      /* In Reader.C, program tagline. */
extern char CurTag[];

extern char HomePath [];   /* Home directory for exe file & root of msg dirs */
extern char MailPath [];   /* Where to look for new mail                     */
extern char ReplyPath[];   /* Where to put replies                           */
extern char WorkPath[] ;   /* Where to archive /unarchive mail               */

extern char CurBoard[] ;   /* name of the current board                      */

extern char Editor  [];    /* Name of the standard text editor               */
extern char Archiver [];
extern char UnArchiver[];

extern struct MyIndex Index ;

extern char ConfName[MAXCONF][NAMCONF]; /* Conference numbers & names      */
extern int  CurConf ;     /* Name of the current Conference...             */
extern int  TotMsg  ;     /* total messages in conf                        */
extern int ReplyExist ;   /* Flag, true if there are replies not packed.   */
extern int ansi       ;   /* ansi graphics or not                          */
extern int IsEmpty    ;   /* Reader empty  or not                          */
extern int HeadLetter ;   /* Automatic header                              */


extern FILE *fidx,*fmsg;  /* Files opened for message and index            */
extern int FilesOpen ;    /* Flag true if these files are opened           */
extern byte *rbuf;        /* Buffer containing current message.            */
extern char *txt[];       /* Language-dependant text messages ( general  ) */
extern char *hlp[];       /* Language-dependant text messages ( help )     */
extern char *Months[];    /* Language-dependant text messages (Dates  )    */

/*------------------------- fin de reader.h -------------------------------*/
