

static char rcsid[] =  "$Id: readlib.c,v 1.30 1992/07/05 15:36:19 root Exp $";

/* Change Log:
$Log: readlib.c,v $
 * Revision 1.30  1992/07/05  15:36:19  root
 * first release of ATP
 *
 * Revision 1.2  1992/04/19  12:51:12  root
 * 1st semifunctional UNIX version.
 *
 */

/*
+--------------------------------------------------------------------------+
|                                                                          |
|  ATP QWK Mail Reader for LINUX Copyleft and Copyright (c) 1992 KI4N TGM  |
|                                                                          |
|       Routines d'essai de reader au format Qmail - R.Cougnenc 90 -       |
|                                                                          |
|                      Small Reader for Qmail format.                      |
|                                                                          |
|        Using only tty mode and printf, this program should be compiled   |
|        on many systems with minor modifications.                         :
|                                                                          |
|                          Ren Cougnenc  1990                             |
|                                                                          |
+--------------------------------------------------------------------------+
*/

#define my_mkdir(x) mkdir(x,S_IRWXU)

#include <stdio.h>
#ifdef __unix__
#include <stdlib.h>
#include <unistd.h>
#endif
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include "reader.h"
#include "qmail.h"
#include "system.h"

#include "ansi.h"
#include "readlib.h"

/*
           Creates the Home Pathname. In the Unix version we look for for
		   the environment variable ATP. If that is not found we look for
		   the HOME variable and make our home path with that. If that 
		   fails we use the current working directory as out home path.
		   If that fails, we exit after printing an error message.
		   Note that Unix doesn't pass the path in argv[0], only the name
		   of the program. The MS-DOS version assumes that argv[0] contains
		   the current path. MakeHomePath is invoked from main() and is
		   passed argv[0].
*/

void MakeHomePath(path)
char *path;
{
 int i;
 char *pt;

#ifdef _unix_

    if(( pt = (char *) getenv("ATP")) != NULL ) {
		   strcpy(HomePath,pt);
		   PrePath(HomePath);
	}
    else if(( pt = (char *) getenv("HOME")) != NULL ) {
	       strcpy(HomePath,pt);
		   PrePath(HomePath);
	}
	else if((pt = getcwd( HomePath, MAXPATHS)) != NULL ) {
		   PrePath(HomePath);
	}
	else {
		    printf("\nERROR: MakeHomePath() module readlib.c\n");
			return ;
	}
#else

    if(( pt = (char *) getenv("ATP")) == NULL )
        strcpy(HomePath,path);
    else
    {
      strcpy(HomePath,pt);
      PrePath(HomePath);
    }
#endif
	
	i = strlen(HomePath);
	while(i)
	{
       	if(HomePath[i] == SEP || HomePath[i] == ':'||
                   HomePath[i] == SEPDOS ) break ;
		HomePath[i] = '\0' ;
		i--;
	}

   pt = HomePath ;
   while(*pt)
   {
     if( *pt == SEPDOS )
       *pt = SEP ;
     pt++;
   }
}
/*----------------------------------------------------------------------*/
/*

                       Read the configuration file.

*/

int ReadConfig()
{
  char Path[MAXPATHS],
       Line[MAXPATHS],
       var[50],
       sign[50],
       value[50],
       value2[50];
  int count = 0, i= 0, donehere=FALSE ;
  FILE *cfg;

  printf("%s...\n",txt[53]);  /* "Reading config file" */
  
  for(i=0; i<TLLEN ; i++)  strcpy( &(taglist[i][0]), "  \n" );/* init. tag array */
  strcpy( UserTag,"  \n" );
#ifdef _unix_
  strcpy( qwklist, "ls *.q* " ); /* initialize qwklist command */
#else
  strcpy( qwklist, "dir *.q* ");
#endif
  strcpy(Path,HomePath);
  strcat(Path,".");
  strcat(Path,CONFIG_FILE);
  if(( cfg = fopen(Path,"r") ) == NULL ){   /* try to open cfg "dot" file */
    strcpy(Path,HomePath);
    strcat(Path,CONFIG_FILE);
    if(( cfg = fopen(Path,"r") ) == NULL ){ /* try again non-dot file     */
	  /* "Unable to open config file" */
      printf("\n%s %s or .%s ! \n",txt[ 52], Path, CONFIG_FILE );
      return( ERROR );
    }
  }

  while( fget(Line,255,cfg) )
  {

    count++ ;
    if(Line[0] == '#' || strlen(Line) < 2 )
      continue;
    sscanf(Line,"%s %s %s %s",var,sign,value,value2 );
    if( (donehere = affect(var,sign,value,value2,Line,cfg))==ERROR )
     {
         /* "error in config file in line..." */
         printf("%s %s %s %d\n",txt[ 54 ],Path,txt[ 55],count);
         printf("%s %d : %s\n", txt[ 56],count,Line);
         return ( ERROR );
	 }
     else if (donehere == DONE )
	       break ;
  }
  return( OK );
}




/*
          Affects known configuration variables to their global values.
          Returns ERROR on an invalid line.
          Ignores unknown variables.
*/

int affect(var,sign,value,value2,Line,fp)
char *var,*sign,*value,*value2,*Line;
FILE *fp ;
{
  char *tptr ;   
  int tmpint,i ;
  strlwr(var);
  if (strcmp(sign,"=")  )
   return( ERROR );

   if( ! strcmp (var, "editor") )
   {
      strcpy(Editor,value);
      return( OK );
   }

   if( ! strcmp (var, "mail") )
   {
#ifdef __unix__
      if(value[0] != SEP) {
	  	getcwd(MailPath,MAXPATHS);
      	PrePath(MailPath);
	  }
      strcat(MailPath,value);
#else
      strcpy(MailPath,value);
#endif
      PrePath(MailPath);
      return( OK );
   }

   if( ! strcmp (var, "reply") )
   {
      strcpy(ReplyPath,value);
      PrePath(ReplyPath);
      return( OK );
   }

   if( ! strcmp (var, "archiver") )
   {
      if((tptr=strstr(Line,value) )!=NULL )
	      strcpy(Archiver, tptr ); 
      else
	      strcpy(Archiver, "zip");
	  return( OK );
   }

   if( ! strcmp (var, "unarchiver") )
   {
      if ( (tptr = strstr(Line,value) )!=NULL )
	      strcpy(UnArchiver, tptr ); 
      else
	      strcpy(UnArchiver, "unzip");
		  return( OK );
   }
   if( ! strcmp (var, "ansi") )   /* Starting in ansi mode or not... */
   {
      strlwr(value);
      ansi = strcmp(value,"on") ? 0 : 1 ;
      return( OK );
   }

   if( ! strcmp (var, "user") )   /* Get User First & Last Name      */
   {
      sprintf(UserName,"%s %s",value,value2);
	  return( OK );
   }

     if( ! strcmp (var, "tagline" ) ) /* Get persistent tagline      */
     {
      tptr = strchr(Line,'=') ;
      tptr++ ; 
      tptr++ ; 
      strcpy(OrigTag, tptr);    /* Copy the Original tagline from config */ 
      strcat(OrigTag, "\n");
	  return( OK );
      }  

     if ( ! strcmp( var, "taglist" ) ) /* read tagline file   */
     {
     for( i=0 ; i<TLLEN ; i++ ) {
         if( fget( &(taglist[i][0]),60, fp ) == NULL ){
         	strcat( &(taglist[i][0]), "\n" ) ; 
            break ;
		 }	
         strcat( &(taglist[i][0]), "\n" ) ; 
      }
      return(DONE); 
	  }

     if( ! strcmp (var, "tagstyle" ) ) /* default tag style Fido or PCB */
     {
      strupr(value);
      if( ! strcmp(value,"FIDO")){
         fido = TRUE ;
         strcpy(CurTag, FidoTag); 
         } 
      return(OK);
	 }

     if( ! strcmp (var, "screenlen" ) ) /* default screenlength */
     {
      if( Numeric(value)) {
          tmpint = atoi(value);
          tmpint = (tmpint < 0 ) ? -tmpint : tmpint;
          if( tmpint>2 && tmpint < 301 )
              SCREENLINES = tmpint ;
          }
      return(OK); 
	  }	

	 if( ! strcmp (var, "qlist" ) ){ /* get command for listing packets */
	      	if(value[0])
	      	   strcpy( qwklist, strstr(Line, value)); 
         	return(OK) ;
         } 
  
}




/*
       Adds the last separator to a pathname.
       Must be room enough for that in the string !
*/

void PrePath( path )
char *path;
{
 int l ;

  l = strlen(path);
  if( path [ l - 1 ] != SEP && path [ l - 1 ] !=  SEPDOS ){
    path[ l ]  = SEP ;
    path[ l+1] = EOS ;
  }
}



/*
            Builts the full work directory pathname, and
            Deletes all files in the work directory.

           ( System dependants functions are in system.c )
*/

void Clean()
{
  strcpy(WorkPath,HomePath);
  strcat(WorkPath,WORK_DIR );

  if( access(WorkPath,0) )
     my_mkdir(WorkPath);
  else
  {
    printf("%s %s...\n",txt[ 57],WorkPath);   /* "Cleaning" */
    Erase(WorkPath);
  }
}


/*
   FGET : Get a string like fgets, without any space or lf on the right.
*/

char *fget (s,n,fp)
char *s;
int n;
FILE *fp;
{
 int ch1, ct = 0 ;  
 char tbuf[300] ;
 char *p1, *p2 ;

 if(n> 300 ) return(NULL);
 
 p1 = p2 = tbuf ;
 while ( ct < n-2 && ct < 300 ) 
 {
	ch1 = fgetc(fp ) ;
	if( ch1 == EOF || ch1 == '\n' )
   		ct = 300 ;
	else if ( ch1 != '\r' ){
    		*p2 = ch1 ;
    		ct++; p2++;
    	} 
}
*p2 = '\0';
StripSpaceR(--p2);
while (ct < 300 )
{
  	ch1 = fgetc(fp);
        if(ch1 == EOF) break;
  	ct++;
  	if(ct==300)
     		return(NULL) ;
  	else  if(ch1=='\n'){
     		ct = 300 ;
   	}
}
strcpy(s,tbuf);
if(ch1 == EOF) 
  return(NULL);
}

/* ------------------------------------------------------------------- */  
/*
           Get conference, open global files etc...
*/

int GetConf(num) /* expects the raw array index as argument */
int num;
{
 char tmp[MAXPATHS];
 struct stat stats;

  sprintf(tmp,"%s%s/%d.idx",HomePath,CurBoard,ConfNumbers[num]);
  if( FilesOpen )
  {
    fclose(fidx);
    fclose(fmsg);
    FilesOpen = FALSE ;
  }

  if( access(tmp,0)) {         /* File does not exists, no mail. */
       red();
       printf("%s %s\n",txt[ 44 ],tmp);  /* "No mail on conf" */
	   return(ERROR);
  }
  else {                    /* Ok file exists, read it . */
#ifdef __unix__
    	if(( fidx = fopen(tmp,"r+") )== NULL )
#else
    	if(( fidx = fopen(tmp,"r+b") )== NULL )
#endif
    	{
       	printf("%s %s\n",txt[49],tmp);  /* "unable to read file" */
		return(ERROR);
    	}

    	if( setvbuf(fidx,NULL,_IOFBF,1024 ) )
      	printf("%sGetConf() [index]\n",txt[ 94 ]);  /* "Setvbuf failed..." */

  }

  stat(tmp,&stats );
  TotMsg  = (int) (stats.st_size / sizeof(struct MyIndex) );

  sprintf(tmp,"%s%s/%d.cnf",HomePath,CurBoard,ConfNumbers[num]);
#ifdef __unix__
  if ( (fmsg = fopen(tmp,"r") ) == NULL )
#else
  if ( (fmsg = fopen(tmp,"rb") ) == NULL )
#endif
  {
     printf("%s %s ! \n",txt[ 58 ],tmp ); /* "Error Reading file" */
     fclose(fidx);
	 return ERROR ;
  }

  if( setvbuf(fmsg,NULL,_IOFBF,VBUF ) )
    printf("%sGetConf() [data]\n",txt[ 94 ]);  /* "Setvbuf failed..." */
                                             /* Go  to Last message read */
  fread((char *)&Index.LastRead,1,sizeof(struct MyIndex),fidx);
  fseek(fidx,(long) Index.LastRead * (long) sizeof(struct MyIndex), 0 );
 CurConf   = num  ;
 FirstDone = FALSE ; 
 FilesOpen = TRUE ;
 return ( OK );
}






/* -----------------------------------------------------------------
        Copy the current msg in file tmpname with quotes.
*/
void QuoteMsg(tmpname)
char *tmpname ;
{

#ifdef LINUX
 extern unsigned char codelu[] ;
#endif
 FILE *fq;
 struct MsgHeaderType  *Msg ;
 int i;
 int col ;
 byte *ptr, *ptr2 ;

 char quote[10];
 char tmp1[MAXPATHS];
 char tmp2[50];
 char tmp[MAXPATHS];
 char ch ;

 Msg = ( struct MsgHeaderType *) rbuf ;

 tmp2[0]=0;
 if( ! strncmp( Msg->Author,"SYSOP",5) )
   strcpy (quote,"Sys> ");
 else
 {
   sscanf(Msg->Author,"%s %s",tmp1,tmp2);         /* First & Last Name */
   sprintf(quote,"%c%c> ",tmp1[0],tmp2[0] ? tmp2[0] : 32 ); /* Initials.. */
 }

 printf("%s %s ...\n",txt[59],quote );  /* "Quoting message with " */

 if( ( fq = fopen(tmpname,"w")) == NULL )
 {
   printf("%s %s !\n",txt[50],tmpname ); /* "Unable to create file" */
   return ;
 }
 if( setvbuf(fq,NULL,_IOFBF,VBUF ) )
   printf("%sQuoteMsg() [temp file]\n",txt[ 94 ]);  /* "Setvbuf failed..." */

 RefMessage(fq,Msg);   /* Dear User, in a message to... */

  ptr = (byte *) (rbuf + sizeof(struct MsgHeaderType ) );
  i = 0 ; 
  fprintf(fq,"%s",quote);
  col = strlen(quote);
  while (i < Index.Size ) 
  {
    if( *ptr == '\n' )
    {
       fprintf(fq,"\n%s",quote);
       col = strlen(quote);
    }
    else if(*ptr!='\0')
    {
      if( col < 77 )  /* Trunc quoted lines to 77 cols */
#ifdef LINUX
        fprintf(fq,"%c",  codelu[ (unsigned) (*ptr)] );
#else
        fprintf(fq,"%c",*ptr) ;
#endif
      col ++ ;
    }
    i++;
    ptr++;
  }
 fclose(fq);
}



/*
                Ralise l'entte de la lettre...
*/

#define PUBLIC    1
#define MYSELF    2

void RefMessage(fp,Msg)
FILE *fp;
struct MsgHeaderType *Msg ;
{
  char Destin[ 30 ];
  char Ref   [ 30 ];
  int mon,day,mod ;

  if( ! HeadLetter )
     return ;

  sscanf(Msg->MsgDate,"%d-%d",&mon,&day);
  Initials(Msg->Author,Destin,25);
  Initials(Msg->ForWhom,Ref, 25 );

  if( ! strncmp( Msg->ForWhom,"ALL",3) )
     mod = PUBLIC ;
  else
  if( ! strncmp( Msg->ForWhom,UserName,strlen(UserName) ) )
    mod  = MYSELF ;
  else
    mod  = 0 ;


  fprintf(fp,"%s %s,\n",txt[96],Destin);              /* "Cher"           */
  fprintf(fp,"%s",txt[97]);                           /* "Dans un msg du" */
  fprintf(fp," %d %s, ", day, Months[ mon - 1 ] );
  switch( mod )
  {
        case PUBLIC :
              fprintf(fp,"%s :\n\n",txt[98]);         /* "vous crivez"   */
        break ;

        case MYSELF :
              fprintf(fp,"%s :\n\n",txt[99]);         /* "vous m'crivez" */
        break ;

        default :
              fprintf(fp,"%s",txt[ 100 ]);            /* "destin "      */
              fprintf(fp," %s, ",Ref);
              fprintf(fp,"%s :\n\n",txt[98]);         /* "vous crivez"   */
  }

}



/*
        Formatte le nom en minuscules, avec les initiales Upcase,
        dans dst, null terminated.
*/
void Initials(str,dst,len)
unsigned char *str,*dst ;
int len ;
{
 int m,i;

   m = 1 ;
   for( i = 0 ; i < len ; i++ )
   {
         *dst = *str  ;
         if( *dst == '.' || *dst == '-' || *dst == ' ' ) {
             	m = 1 ; /* Next must be Upcase */
         		if ( m ) { 
					if ( ! strnicmp( ++str, "mc", 2 )) {
			            dst++ ; 
						*dst = 'M' ;	
						str++ ; dst++ ; 
			            *dst = 'c' ;	
						i+=2 ;	
						}
			 		else
		        		str-- ;	
         		}
		 }
		else {
            *dst = m ? toupper( *dst ) : tolower( *dst );
             m = 0 ;
        }
        str++;
        dst++ ;
   	}

   *dst = 0 ;                /* build a null-terminated string */
   	dst --;
   	while ( *dst == 32 ){
        *dst = 0 ;
        dst--;
	}
        
   
   
}



/*
             more : prompts "more  ?" and wait for yes, oui, ja .
             returns  1 for yes, 0 for no.
             'def ' manages the CR default answer.

*/

int more(def)
int def;
{
 char tmp[10];

  for(;;)
  {
     high(); yellow();
     printf(" %s ? : ",txt[ 60 ]);
     fget(tmp,5,stdin);
     switch( (int) tmp[0])
     {
            case 'o' :
            case 'y' :
            case 'O' :
            case 'Y' :
            case 'j'  :
            case 'J'  :
            clear();
            up(1);
            printf("\r              \r");
            return ( 1 );

            case 'N' :
            case 'n' :
            clear();
            return( 0 );

            case 0   :  /* CR */
                if( def == YES )
                {
                     clear();
                     up(1);
                     printf("\r              \r");
                     return ( 1 );
                }
                else
                {
                     clear();
                     return( 0 );
                }

     }
  }
}



/*
             YesNo : prompts "Y/N : " and wait for yes, oui, ja .
             returns  1 for yes, 0 for no.

*/

int YesNo(def)
int def;
{
 char tmp[10];

  for(;;)
  {
     printf(" %s : ",txt[ 61 ]);
     fget(tmp,5,stdin);
     switch( (int) tmp[0])
     {
            case 'o' :
            case 'y' :
            case 'O' :
            case 'Y' :
            case 'j'  :
            case 'J'  :
              printf("\r");
            return ( 1 );

            case 'N' :
            case 'n' :
              printf ("\r");
            return( 0 );

            case 0   :  /* CR */
                if( def == YES )
                     return ( 1 );
                else
                     return( 0 );

     }
  }
}


void PackReply(void) {
  	
	char RepFile[MAXPATHS];
  	char MsgFile[MAXPATHS];
  	char Command[MAXPATHS];

  	sprintf(RepFile,"%s%s.rep",ReplyPath,CurBoard);
  	if( !access(RepFile,0) ){
    	red(); high();
    /* "Warning ! file already exist " "delete it ?" */
    	printf("%s   %s %s %s...!\n",txt[2],txt[62],RepFile,txt[63]);
    	printf("            %s ",txt[ 64 ]);
    	if(YesNo(YES))
			unlink(RepFile);
		else
        	return;
  	}
  	sprintf(MsgFile,"%s/%s.msg",WorkPath,CurBoard);
  	sprintf(Command,"%s %s %s",Archiver,RepFile,MsgFile);
  	yellow();high();
  	printf("%s %s\n",txt[ 65 ],RepFile );  /* "packing replies in" */
  	green();
  	system(Command);
  	ReplyExist = FALSE ;
  	unlink(MsgFile);
}



/*
   UPDATECONF:  Write only if necessary the last read pointer in the
   first index structure of the file.
*/
void UpdateConf() {
  extern int ActvCnt ;
  struct MyIndex Idx ;
  
  if( ActvCnt < 1 ||  !(ConfActive[CurConf]) ) {
      printf("No active conference to update.\n");
	  if(FilesOpen)  
		printf("ERROR: module UpdateConf() -- open files, inactive Conf\n");
	  return ;
  }
		
  if(! FilesOpen ) {
      printf("ERROR: module UpdateConf() -- bad file pointer for fseek()\n") ;
  	  return ;
  } 
  
  if( fseek( fidx,0L,SEEK_SET ) )
  {
        /* printf("Seek error...\n"); */
        return ;
  }
  fread((char *)&Idx.LastRead,1,sizeof(struct MyIndex),fidx);
  if( Idx.LastRead < Index.MsgNum )
  {
        Idx.LastRead = Index.MsgNum ;
        fseek( fidx,0L,SEEK_SET );
        fwrite((char *)&Idx.LastRead,1,sizeof(struct MyIndex),fidx);
        printf("%s.\n",txt[66]); /* "Last read pointer updated" */
  }
}

/*------------------------------------------------------------------------*/
/*
    NPRINT: Print a string not null-terminated on stdout.
*/
void nprint(str,len)
byte *str;
int len;
{
      while(len--) putchar(*str++);
}
/*------------------------------------------------------------------------*/

/*------------------------------------------------------------------------*/
/*
    NFPRINT: Print a string not null-terminated in file fp
*/
void nfprint(fp,str,len)
FILE *fp;
byte *str;
int len;
{
      while(len--) fputc(*str++,fp);
}
/*------------------------------------------------------------------------*/



/*----------------------------------------------------------------------*/
/*  STR2MEM :
            copies a string without the null character in order to fill
            correctly the Qmail header.
*/

void str2mem(mem,str)
char *mem, *str;
{

     while(*str)
      {
            *mem = *str;
            str++;
            mem++;
      }
}
/*----------------------------------------------------------------------*/


/*
    scpy : copies len bytes to src, deleting left spaces.
*/
void scpy(dest,src,len)
char *dest,*src;
int len;
{
   register int i;

   for( i = 0 ; i < len ; i ++)
      *(dest +i )= *(src + i );

   *(dest + i )  =  0 ;

   i--;
   while( *(dest + i ) == 32 )
   {
      *(dest + i )  = 0 ;
      i--;
   }

}




/*
           FCOPY : fast copy of a file.
                   return :  0 on success
                             1 on error
*/
int fcopy(source,destin )
char *source;
char *destin;
{
  int src,
      dst;
#ifdef __unix__
  int perm = S_IRUSR | S_IWUSR ;
  int acc  = O_RDWR | O_CREAT | O_TRUNC ;
#else
  int perm = S_IREAD | S_IWRITE ;
  int acc  = O_RDWR | O_BINARY | O_CREAT | O_TRUNC ;
#endif
  int nb;
  char *buf;

  if(( buf = malloc ( 4096 ) ) == NULL )
  {
     printf("%s",txt[1] );
     return ( 1 );
  }

#ifdef __unix__
  if(  ( src  = open (source,O_RDONLY ) ) == -1 )
#else
  if(  ( src  = open (source,O_RDONLY | O_BINARY) ) == -1 )
#endif
  {
      printf("%s %s\n",txt[49],source );  /* "unable to read file" */
      free( buf );
      return( 1 );
  }

  if(  ( dst  = open (destin,acc,perm) ) == -1 )
  {
      printf("%s %s\n",txt[50],source ); /* "unable to create file" */
      free( buf );
      return( 1 );
  }

  while( (nb  = read ( src, buf, 4096 )) )
  {
          write( dst,buf, nb  );
  }
  close( src );
  close( dst );
  free( buf );
 return( 0 );
}


/*
            VIEW :         View a file with more.
*/
void view(Path,File)
char *Path,*File;
{
#ifdef LINUX    /* used for translating DOS chars to LINUX chars */ 
  extern unsigned char codelu[] ;
  unsigned char *ptr ;
#endif

  FILE *fp;
  char tmp[MAXPATHS];
  unsigned char buf[513] ;
  int line =  0 ;

  sprintf(tmp,"%s/%s",Path,File );
  if((fp = fopen(tmp,"r") )== NULL )
  {
     red();
     printf("%s %s\n",txt[ 67 ], tmp ); /* "No file" */
     return ;
  }
  clear();
  cyan();
  printf("\n\n");
  while( fget(buf,250,fp ) )
  	{
   	line++ ;
    	if( line > SCREENLINES - 7 )
      		{
        	line = 0 ;
        	if( ! more(YES) )
          		break ;
        	cyan();
      	}
#ifdef LINUX    /* translate DOS character set to LINUX character set */
   	ptr = buf ;
   	while ( *ptr != '\0' )
        	{
        	*ptr = codelu[ (unsigned) (*ptr) ] ;
        	ptr++ ;
        	}
#endif
   	puts(buf) ;
  	}
  fclose(fp);
}


/*
   Si un rigolo tape ce mot dans le shell...
*/
void merde()
{
  magenta();high();
  printf("\n");
  printf("Espce de petit connard, on t'a pas appris la politesse  ???%c\n",7);
  printf("Va te faire foutre !!!\n\n");
}

/*
    NUMERIC : Returns 1 if the string is a number, 0 if not.
*/
int Numeric( str )
char *str;
{
  if( *str == 0 )
   return( 0 );
  while( *str )
  {
    if( *str < '0' || *str > '9' )
     return ( 0 );
   str++;
  }
  return ( 1 );
}

/*
  IsQuoted(str)   Returns 1 if the string contains c in the 15 left chars.
*/

int IsQuoted(c,str)
int c;
char *str ;
{
 register int i;

 for(i = 0 ; i < 15 ; i ++ )
  {
    if( *str == 0 )   return ( 0 );
    if( *str++ == c ) return ( 1 );
  }
 return ( 0 );
}

/*
     DATE : prints the date :-)
*/

void Date()
{
  long t;
  blue(); high();
  time(&t);
  printf(ctime(&t) );
}

/*
    EmptyMsg : Tell that there is no BBs loaded.
*/

void EmptyMsg()
{
  red(); high();
  printf("%s ",txt[ 68 ] );       /* "Hey !" */
  clear();magenta();
  printf("%s\n",txt[69]);         /* There is no bbs loaded !"*/
  printf("%s...\n",txt[ 70 ]);    /* use 'read' 'load' or 'help' command"*/
  clear();
}

/* ShiftLeft shifts a string n positions left at p1 */

int ShiftLeft(char *p1, int n) 
    {
    char *p2 ;
     
    p2 = p1 ;
    p2++ ; 
    if(n==2) p2++ ;  
    while(*p2 != '\0' ) 
      {
      *p1 = *p2  ;
      p2++ ; p1++ ;
      }
      *p1= '\0'; 
    return(1);
    }


/* Scans a line until there are no more backspace or del characters */


int StripDel(char *tp )
    {
char *p ;
p = tp ;
while(*p!='\0') {
    if(p == tp)         
    switch (*p) {  
	
		case '\010' :                     /* backspace */
                
	    case '\177' : ShiftLeft(p,1);     /* del       */
                       break;
       
        case '\0'  : return;

		default    : p++  ;
     }
    
    else 
        switch (*p) {

			case '\010' :                    

			case '\177' : p-- ;
                          ShiftLeft(p,2);
                          break;

    		case '\0'   :  return;

			default     :  p++ ;       
       }
    
  }
}

/*  Qlist sets up shell command line for listing QWK packets in the
    mail directory  sorted by creadtion time 
*/

int Qlist ( char *cmdlist ) {

	char  tmp [MAXPATHS] ; 

#ifdef __unix__
	if (getcwd(tmp, sizeof(tmp)) == NULL) ; 	/* save current directory    */
	chdir(MailPath);                            /* change to Mail directory  */
	system(cmdlist);                            /* execute command line      */
	chdir(tmp);                                 /* restore current directory */
#else
    system(cmdlist);
#endif
}
/*------------------------------------------------------------------------*/
